#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "rug520.h"

//Link to RUG520.lib with header file above

void main() {
   //Initialize parameters and local variables
   char mdsRecord[1815];
   char c_rehab[6];
   char c_model[3];
   int quarterFlag = 0;
   double n_cmi[59];
   char c_rug_hr[4];
   char c_rug_mx[4];
   int n_rug_hr;
   int n_rug_mx;
   double cmiValue_hr, cmiValue_mx;
   int adlSum , cpsCode, error;
   char rugVersion[3], dllVersion[5], outFileName[80];
   char buf[20];
   FILE * fptr, * wptr, * eptr;
   int i, j, k, retValue;

   //Select normal Rehabilitation classification (ignoring ordered therapies)
   strcpy( c_rehab, "other");
   //Select 34-group model
   strcpy( c_model, "34" );
   //Create output file name "out_hier34.txt"
   strcpy( outFileName, "out_hier" );
   strcat( outFileName, c_model );
   strcat( outFileName, ".txt" );
   //Load 34-group CMI set D01
   if ( strcmp(c_model, "34") == 0 ) {
        n_cmi[ 0] = 0;
        n_cmi[ 1] = 0;
        n_cmi[ 2] = 0;
        n_cmi[ 3] = 0;
        n_cmi[ 4] = 0;
        n_cmi[ 5] = 0;
        n_cmi[ 6] = 0;
        n_cmi[ 7] = 0;
        n_cmi[ 8] = 0;
        n_cmi[ 9] = 0;
        n_cmi[10] = 0;
        n_cmi[11] = 0;
        n_cmi[12] = 0;
        n_cmi[13] = 0;
        n_cmi[14] = 0;
        n_cmi[15] = 0;
        n_cmi[16] = 0;
        n_cmi[17] = 0;
        n_cmi[18] = 0;
        n_cmi[19] = 0;
        n_cmi[20] = 0;
        n_cmi[21] = 0;
        n_cmi[22] = 0;
        n_cmi[23] = 0;
        n_cmi[24] = 2.10;
        n_cmi[25] = 1.79;
        n_cmi[26] = 1.54;
        n_cmi[27] = 1.66;
        n_cmi[28] = 1.31;
        n_cmi[29] = 1.24;
        n_cmi[30] = 1.07;
        n_cmi[31] = 1.44;
        n_cmi[32] = 1.33;
        n_cmi[33] = 1.28;
        n_cmi[34] = 1.42;
        n_cmi[35] = 1.25;
        n_cmi[36] = 1.15;
        n_cmi[37] = 1.07;
        n_cmi[38] = 1.06;
        n_cmi[39] = 0.95;
        n_cmi[40] = 0.88;
        n_cmi[41] = 0.85;
        n_cmi[42] = 0.72;
        n_cmi[43] = 0.67;
        n_cmi[44] = 0.86;
        n_cmi[45] = 0.82;
        n_cmi[46] = 0.71;
        n_cmi[47] = 0.60;
        n_cmi[48] = 1.00;
        n_cmi[49] = 0.97;
        n_cmi[50] = 0.91;
        n_cmi[51] = 0.89;
        n_cmi[52] = 0.83;
        n_cmi[53] = 0.81;
        n_cmi[54] = 0.65;
        n_cmi[55] = 0.63;
        n_cmi[56] = 0.62;
        n_cmi[57] = 0.59;
        n_cmi[58] = 0.59;
   }

   //Open test data set "test520a_max.txt"
   fptr = fopen( "test520a_max.txt", "r" );
   //Open output file for checking RUG-III classification
   wptr = fopen( outFileName, "w" );
   //Open output file for listing records with errors
   eptr = fopen( "ErrorRecords.txt", "w" );

   //Setup output file title
   if ( strcmpi( c_rehab, "other") == 0 ) {
        if ( strcmp( c_model, "53" ) ==0 ) fprintf( wptr, "    Rug5.20 53 Group Hierarchical\n" );
        else if ( strcmp( c_model, "34" ) ==0 ) fprintf( wptr, "    Rug5.20 34 Group Hierarchical\n" );
        else if ( strcmp( c_model, "44"  )==0 ) fprintf( wptr, "    Rug5.20 44 Group Hierarchical\n" );
   }
   else if ( strcmpi( c_rehab, "mcare") == 0 ) {
       if ( strcmp( c_model, "53" ) ==0 ) fprintf( wptr, "    Rug5.20 53 Group MCare\n" );
       else if ( strcmp( c_model, "34" ) ==0 ) fprintf( wptr, "    Rug5.20 34 Group MCare\n" );
       else if ( strcmp( c_model, "44"  )==0 ) fprintf( wptr, "    Rug5.20 44 Group MCare\n" );
   }

   //Setup output file column headings
   fprintf( wptr, " Record No.  c_rug_hr        cmiValue_hr      adlSum cpsCode RugVersion\n" );
   fprintf( wptr, "            Calc  File     Calc      File      C   F   C  F    C    F\n" );
   j = 0;
   k = 0;

   //Process each test record, perform RUG-III with rugcalc( ), output results and errors
   while ( fgets(mdsRecord, 1815, fptr) != NULL ) {
           printf( "Record Number = %d\n", ++j );
	       if ( mdsRecord[0] != 'B' ) continue;
		   retValue = RugCalc( mdsRecord, c_rehab, c_model, quarterFlag, n_cmi, 
			                   c_rug_hr, c_rug_mx, &n_rug_hr, &n_rug_mx, 
							   &cmiValue_hr, &cmiValue_mx, &adlSum, &cpsCode, 
							   rugVersion, dllVersion, &error );
		   if ( error > 0 ) {
		        fprintf( eptr, "Number of Errors = %d, ", ++k );
			    fprintf( eptr, "Error Number = %d - Record Number = %d\n", error, j );
				continue;
		   }
		   if ( retValue ) {
		        fprintf( eptr, "Number of Errors = %d, ", ++k );
				fprintf( eptr, "Data Validation Failed - Record Number = %d\n", j );
                continue;
		   }
		   if ( strcmp( c_model, "53" )==0 ) {
			    fprintf( wptr, "     %4d   ", j );
			    fprintf( wptr, " %s", c_rug_hr );
		        fprintf( wptr, "  %c%c%c ", mdsRecord[1291],mdsRecord[1292],mdsRecord[1293] );
                sprintf( buf, "%8.4f", cmiValue_hr ); 
				fprintf( wptr, " %s", buf );
				for ( i=0; i<10; i++ ) buf[i] = mdsRecord[1297+i];
                buf[10] = '\0';
				fprintf( wptr, " %s", buf );
		        fprintf( wptr, "    %2d ", adlSum );
		        fprintf( wptr, " %c%c ", mdsRecord[1322],mdsRecord[1323] );
		        fprintf( wptr, "  %d ", cpsCode );
		        fprintf( wptr, " %c ", mdsRecord[1324] );
		        fprintf( wptr, "   %s ", rugVersion );
		        fprintf( wptr, " %c%c\n", mdsRecord[1320], mdsRecord[1321] );
		   }
		   else if ( strcmp( c_model, "34" )==0 ) {
			    fprintf( wptr, "     %4d   ", j );
			    fprintf( wptr, " %s", c_rug_hr );
		        fprintf( wptr, "  %c%c%c ", mdsRecord[1229],mdsRecord[1230],mdsRecord[1231] );
                sprintf( buf, "%8.4f", cmiValue_hr ); 
				fprintf( wptr, " %s", buf );
				for ( i=0; i<10; i++ ) buf[i] = mdsRecord[1235+i];
                buf[10] = '\0';
				fprintf( wptr, " %s", buf );
		        fprintf( wptr, "    %2d ", adlSum );
		        fprintf( wptr, " %c%c ", mdsRecord[1322],mdsRecord[1323] );
		        fprintf( wptr, "  %d ", cpsCode );
		        fprintf( wptr, " %c ", mdsRecord[1324] );
		        fprintf( wptr, "   %s ", rugVersion );
		        fprintf( wptr, " %c%c\n", mdsRecord[1258], mdsRecord[1259] );
		   }
		   else if ( strcmp( c_model, "44" )==0 ) {
			    fprintf( wptr, "     %4d   ", j );
			    fprintf( wptr, " %s", c_rug_hr );
		        fprintf( wptr, "  %c%c%c ", mdsRecord[1260],mdsRecord[1261],mdsRecord[1262] );
                sprintf( buf, "%8.4f", cmiValue_hr ); 
				fprintf( wptr, " %s", buf );
				for ( i=0; i<10; i++ ) buf[i] = mdsRecord[1266+i];
                buf[10] = '\0';
				fprintf( wptr, " %s", buf );
		        fprintf( wptr, "    %2d ", adlSum );
		        fprintf( wptr, " %c%c ", mdsRecord[1322],mdsRecord[1323] );
		        fprintf( wptr, "  %d ", cpsCode );
		        fprintf( wptr, " %c ", mdsRecord[1324] );
		        fprintf( wptr, "   %s ", rugVersion );
		        fprintf( wptr, " %c%c\n", mdsRecord[1289], mdsRecord[1290] );
				}
   }
   printf( "Error count = %d\n", k );
   fclose( eptr );
   fclose( wptr );
   fclose( fptr );
   getch();
}
