VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Rugs DLL Test Program"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   2520
      TabIndex        =   2
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   495
      Left            =   720
      TabIndex        =   0
      Top             =   2160
      Width           =   1335
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      Height          =   1215
      Left            =   240
      TabIndex        =   1
      Top             =   480
      Width           =   4095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Note: Your function declaration must match the following EXACTLY.
'This includes the use of the ALIAS clause and the ByVal and ByRef
'references for the individual parameters.  Also, note that even though
'several parameters are treated as integer in the DLL, they must be
'declared as LONG in VB6.  If you deviate from this function declaration
'and its usage, you may encounter errors.
Private Declare Function RugCalc Lib "Rug520.dll" Alias "_RugCalc@64" _
    (ByVal sMdsRecord As String, ByVal sRehabType As String, ByVal sModel As String, _
     ByVal lQuarterlyFlag As Long, ByRef nCmiArray As Double, ByVal sRugHier As String, _
     ByVal sRugMax As String, ByRef lRugHier As Long, ByRef lRugMax As Long, _
     ByRef nCmiValueHier As Double, ByRef nCmiValueMax As Double, _
     ByRef lAdlSum As Long, ByRef lCpsCode As Long, ByVal sRugsVersion As String, _
     ByVal sDllVersion As String, ByRef lError As Long) As Long

Sub cmdRun_Click()
    'This routine illustrates the use of Rug520.DLL
    '
    'Please refer to the accompanying documentation file for complete
    'details about using the DLL.
    '
    'This demo reads an input file containing test data.  For each
    'record it reads, it calls the RugCalc() function.  Each record in
    'the test data file contains fields showing the values that should
    'be returned by RugCalc().  For each record processed, the program
    'writes out a record containing the calculated values and the
    'expected values.
    
                                    '---Miscellaneous variables---
    Dim sMDSFile As String          'Name of MDS test input file
    Dim sMdsRecord As String        'Buffer to hold MDS record
    Dim sResultFile As String       'Name of test output file
    Dim iFileNumIn As Integer       'Input file number
    Dim iFileNumOut As Integer      'Output file number
    Dim iRec As Integer             'Record processed counter
    Dim iErrorCount As Integer      'Error counter
    
                                    '---RugCalc() parameters---
    Dim lValue As Long              'Return value from RugCalc()
    Dim sRehabType As String        'Mcare vs. Other
    Dim sModel As String            'RUGs model (34, 44, 53 group)
    Dim lQuarterlyFlag As Long      'Option for processing quarterlies
    Dim nCmiArray(58) As Double     'Case mix index array
    Dim sRugHier As String          'Hierarchical RUG (character code)
    Dim sRugMax As String           'Index maximized RUG (character code)
    Dim lRugHier As Long            'Hierarchical RUG (numeric code)
    Dim lRugMax As Long             'Index maximized RUG (numeric code)
    Dim nCmiValueHier As Double     'Hierarchical RUG (CMI value)
    Dim nCmiValueMax As Double      'Index maximized RUG (CMI value)
    Dim lAdlSum As Long             'ADL sum
    Dim lCpsCode As Long            'CPS score
    Dim sRugVersion As String       'RUG model version
    Dim sDllVersion As String       'DLL version
    Dim lError As Long              'Error code
    
                                    '---Check values (from test recs)---
    Dim sRugHierCheck As String     'Hierarchical RUG (character code)
    Dim sRugMaxCheck As String      'Index maximized RUG (character code)
    Dim sCmiHierCheck As String     'Hierarchical RUG (CMI value)
    Dim sCmiMaxCheck As String      'Index maximized RUG (CMI value)
    Dim sCmiMaxSetCheck As String   'CMI set name
    Dim sRugVersionCheck As String  'RUG model version
    Dim sAdlSumCheck As String      'ADL sum
    Dim sCpsCodeCheck As String     'CPS score
       
    'Disable RUN button
    cmdRun.Enabled = False
    
    'Set up names of input and output files for testing
    sMDSFile = App.Path & "\test520a_max.txt"
    sResultFile = App.Path & "\demo520_vb6.txt"
    
    'Open input file
    iFileNumIn = FreeFile
    Open sMDSFile For Input As iFileNumIn
    
    'Open output file
    iFileNumOut = FreeFile
    Open sResultFile For Output As iFileNumOut
        
    'Load case mix indices into local arrays.
    'For this demo, we load only the CMIs for
    'the 53-group model.
    Call LoadCmi(nCmiArray())
        
    'Initialize record counter
    iRec = 0
    iErrorCount = 0
    
    'Process input file
    Do Until EOF(iFileNumIn)
    
        'Read a record and update record counter display
        Line Input #iFileNumIn, sMdsRecord
        iRec = iRec + 1
        lblStatus.Caption = "Processing " & iRec
        DoEvents
        
        'To perform the RUGs calculation, you must follow these three steps:
        '   1.  Set certain required input variables.
        '   2.  Call the RugCalc() function.
        '   3.  Retrieve the output variables.
        
        'Set up variables for function call
        sRehabType = "Other"    'Sets calculation type
        sModel = "53"             'Sets up model type (53-group)
        lQuarterlyFlag = 0       'Sets quarterly flag
        sRugHier = Space(3)
        sRugMax = Space(3)
        lRugHier = 0
        lRugMax = 0
        nCmiValueHier = 0
        nCmiValueMax = 0
        lAdlSum = 0
        lCpsCode = 0
        sRugVersion = Space(2)
        sDllVersion = Space(3)
        
        
        'Call the RugCalc() function to perform calculation
        lValue = RugCalc(sMdsRecord, _
           sRehabType, _
           sModel, _
           lQuarterlyFlag, _
           nCmiArray(0), _
           sRugHier, _
           sRugMax, _
           lRugHier, _
           lRugMax, _
           nCmiValueHier, _
           nCmiValueMax, _
           lAdlSum, _
           lCpsCode, _
           sRugVersion, _
           sDllVersion, _
           lError)
                
       'Retrieve rugs values from the MDS input record.  These will be written
       'to the output record for testing (i.e., for comparison with the
       'calculated RUGs value)
       sRugHierCheck = Mid$(sMdsRecord, 1292, 3)
       sRugMaxCheck = Mid$(sMdsRecord, 1295, 3)
       sCmiHierCheck = Mid$(sMdsRecord, 1298, 10)
       sCmiMaxCheck = Mid$(sMdsRecord, 1308, 10)
       sCmiMaxSetCheck = Mid$(sMdsRecord, 1318, 3)
       sRugVersionCheck = Mid$(sMdsRecord, 1321, 3)
       sAdlSumCheck = Mid$(sMdsRecord, 1323, 2)
       sCpsCodeCheck = Mid$(sMdsRecord, 1325, 1)

       'Check for errors (mismatch between calculated and
       'expected RUG groups.
       If sRugHierCheck <> sRugHier Or sRugMaxCheck <> sRugMax Then
          iErrorCount = iErrorCount + 1
       End If

       'Write output record
       Write #iFileNumOut, _
           iRec, _
           sRugHier, _
           sRugMax, _
           lRugHier, _
           lRugMax, _
           nCmiValueHier, _
           nCmiValueMax, _
           lAdlSum, _
           lCpsCode, _
           sRugVersion, _
           sDllVersion, _
           lError, _
           sRugHierCheck, _
           sRugMaxCheck, _
           sCmiHierCheck, _
           sCmiMaxCheck, _
           sCmiMaxSetCheck, _
           sRugVersionCheck, _
           sAdlSumCheck, _
           sCpsCodeCheck
     
    Loop
    
    'Update record processing display
    lblStatus.Caption = iRec & " records processed." & Chr(10) & _
       iErrorCount & " errors encountered."
    
    'Close input and output files
    Close #iFileNumIn
    Close #iFileNumOut

End Sub

Sub LoadCmi(raCmi() As Double)
   
   '  SET CODE:  C03
   '  SET NAME:  Medicare rural 53-group model
      
      raCmi(0) = 0   'Element 0 is not used -- set to zero
      raCmi(1) = 53
      raCmi(2) = 52
      raCmi(3) = 48
      raCmi(4) = 46
      raCmi(5) = 42
      raCmi(6) = 41
      raCmi(7) = 47
      raCmi(8) = 44
      raCmi(9) = 32
      raCmi(10) = 51
      raCmi(11) = 50
      raCmi(12) = 49
      raCmi(13) = 45
      raCmi(14) = 43
      raCmi(15) = 40
      raCmi(16) = 39
      raCmi(17) = 37
      raCmi(18) = 35
      raCmi(19) = 36
      raCmi(20) = 34
      raCmi(21) = 33
      raCmi(22) = 30
      raCmi(23) = 26
      raCmi(24) = 38
      raCmi(25) = 31
      raCmi(26) = 29
      raCmi(27) = 0
      raCmi(28) = 0
      raCmi(29) = 0
      raCmi(30) = 0
      raCmi(31) = 28
      raCmi(32) = 25
      raCmi(33) = 24
      raCmi(34) = 27
      raCmi(35) = 23
      raCmi(36) = 22
      raCmi(37) = 21
      raCmi(38) = 20
      raCmi(39) = 17
      raCmi(40) = 14
      raCmi(41) = 12
      raCmi(42) = 8
      raCmi(43) = 6
      raCmi(44) = 13
      raCmi(45) = 10
      raCmi(46) = 7
      raCmi(47) = 2
      raCmi(48) = 19
      raCmi(49) = 18
      raCmi(50) = 16
      raCmi(51) = 15
      raCmi(52) = 11
      raCmi(53) = 9
      raCmi(54) = 5
      raCmi(55) = 4
      raCmi(56) = 3
      raCmi(57) = 1
      raCmi(58) = 1

End Sub

Private Sub cmdQuit_Click()
    End
End Sub


