#include "rug520.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

char masItemVal[108][5];

void LoadValue( char * sMdsRecord, int location, int length, char * masItemValue ) 
{  
   for ( int i=0; i<length; i++ ) masItemValue[i] = sMdsRecord[location+i];
   masItemValue[length] = '\0';
}

int LoadRange() 
//Routine to check valid value range for each MDS RUG-III item
{
   int i, bValue = 0, miItemCnt = 108;
   char masItemName[108][6] = { "aa8b","b1","b2a","b4","c4","e1a","e1b","e1c","e1d","e1e",
                                "e1f","e1g","e1h","e1i","e1j","e1k","e1l","e1m","e1n","e1o",
                                "e1p","e4aa","e4ba","e4ca","e4da","e4ea","g1aa","g1ab","g1ba","g1bb",
                                "g1ha","g1ia","g1ib","h3a","h3b","i1a","i1r","i1s","i1v","i1w",
                                "i1z","i2e","i2g","j1c","j1e","j1h","j1i","j1j","j1o","k3a",
								"k5a","k5b","k6a","k6b","m1a","m1b","m1c","m1d","m2a","m4b",
								"m4c","m4g","m5a","m5b","m5c","m5d","m5e","m5f","m5g","m5h",
								"m6b","m6c","m6f","n1a","n1b","n1c","o3","p1aa","p1ab","p1ac",
								"p1ag","p1ah","p1ai","p1aj","p1ak","p1al","p1baa","p1bab","p1bba","p1bbb",
								"p1bca","p1bcb","p1bda","p3a","p3b","p3c","p3d","p3e","p3f","p3g",
								"p3h","p3i","p3j","p7","p8","t1b","t1c","t1d" };
   char masItemRange[108][12] = { "12345678 ","01-","01- ","0123- ","0123- ","012- ","012- ","012- ","012- ","012- ",
                                  "012- ","012- ","012- ","012- ","012- ","012- ","012- ","012- ","012- ","012- ",
                                  "012- ","0123- ","0123- ","0123- ","0123- ","0123- ","012348-","01238-","012348-","01238-",
                                  "012348-","012348-","01238-","01-","01-","01-","01-","01-","01-","01-",
                                  "01-","01-","01-","01-","01-","01-","01-","01-","01-","01-",
								  "01-","01-","01234- ","012345- ","0123456789-","0123456789-","0123456789-","0123456789-","01234-","01-",
								  "01-","01-","01-","01-","01-","01-","01-","01-","01-","01-",
								  "01-","01-","01-","01-","01-","01-","01234567-","01-","01-","01-",
								  "01-","01-","01-","01-","01-","01-","01234567-","----","01234567-","----",
								  "01234567-","----","01234567-","01234567-","01234567-","01234567-","01234567-","01234567-","01234567-","01234567-",
								  "01234567-","01234567-","01234567-","--","--","01- ","--,  ","----,    " };
   int maiItemLen[108] = { 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
						   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,4,
						   1,4,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,4 };
   char masItemFrom[108][5] = { "", "", "", "", "", "", "", "", "", "", 
		                        "", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "", "", "", 
								"", "", "", "", "", "", "", "0000", "", "0000",
								"", "0000", "", "", "", "", "", "", "", "",  
								"", "", "", "00", "00", "", "00", "0000" };
   char masItemTo[108][5] = { "", "", "", "", "", "", "", "", "", "",
		                      "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "", "", "",
							  "", "", "", "", "", "", "", "9999", "", "9999",
							  "", "9999", "", "", "", "", "", "", "", "", 
							  "", "", "", "14", "14", "", "15", "9999" };
   for ( i=0; i<miItemCnt; i++ ) {
         if ( i!=87 && i!=89 && i!=91 && i!=103 && i!=104 && i!=106 && i!=107 ) {
		      if ( strchr(masItemRange[i], masItemVal[i][0]) == NULL ) {
			       bValue = 1;
				   break;
		      }
	     }
	     if ( i==87 || i==89 || i==91 ) {
			  if ( strcmp( masItemVal[i], "----" )!=0 ) {
				   if ( masItemVal[i][0] < '0' || masItemVal[i][0] > '9' ) {
					   bValue = 1;
					   break;
				   }
				   else if ( masItemVal[i][1] < '0' || masItemVal[i][1] > '9' ) {
					   bValue = 1;
					   break;
				   }
				   else if ( masItemVal[i][2] < '0' || masItemVal[i][2] > '9' ) {
					   bValue = 1;
					   break;
				   }
				   else if ( masItemVal[i][3] < '0' || masItemVal[i][3] > '9' ) {
					   bValue = 1;
					   break;
				   }
			  }
	     }
		 if ( i==103 || i==104 ) {
			  if ( strcmp( masItemVal[i], "--" )!=0 ) {
				   if ( masItemVal[i][0] < '0' || masItemVal[i][0] > '1' ) {
				        bValue = 1;
					    break;
				   }
				   else if ( masItemVal[i][0] == '0' && 
					         (masItemVal[i][1] < '0' || masItemVal[i][1] > '9') ) {
				        bValue = 1;
					    break;
				   }
				   else if ( masItemVal[i][0] == '1' && 
					         (masItemVal[i][1] < '0' || masItemVal[i][1] > '4') ) {
				       bValue = 1;
					   break;
				   }
			  }
		 }
		 if ( i == 106 ) {
			  if ( strcmp( masItemVal[i], "--" )!=0 && strcmp( masItemVal[i], "  " )!=0 ) {
				   if ( masItemVal[i][0] < '0' || masItemVal[i][0] > '1' ) {
				        bValue = 1;
					    break;
				   }
				   else if ( masItemVal[i][0] == '0' && 
					         (masItemVal[i][1] < '0' || masItemVal[i][1] > '9') ) {
				        bValue = 1;
					    break;
				   }
				   else if ( masItemVal[i][0] == '1' && 
					         (masItemVal[i][1] < '0' || masItemVal[i][1] > '5') ) {
				       bValue = 1;
					   break;
				   }
			  }
		 }
		 if ( i==107 ) {
			  if ( strcmp( masItemVal[i], "----" )!=0 && strcmp( masItemVal[i], "    " )!=0  ) {
				  if ( masItemVal[i][0] < '0' || masItemVal[i][0] > '9' ) {
					   bValue = 1;
					   break;
				  }
				  else if ( masItemVal[i][1] < '0' || masItemVal[i][1] > '9' ) {
					   bValue = 1;
					   break;
				  }
				  else if ( masItemVal[i][2] < '0' || masItemVal[i][2] > '9' ) {
					   bValue = 1;
					   break;
				  }
				  else if ( masItemVal[i][3] < '0' || masItemVal[i][3] > '9' ) {
					   bValue = 1;
					   break;
				  }
			  }
		 }
   }
   return bValue;
}


#ifdef SOLARIS
int RugCalc( char * sMdsRecord, char * sRehabType, char * sModel, int iQuarterlyFlag, 
			 double nCmiArray[], char * sRugHier, char * sRugMax, int * iRugHier,
			 int * iRugMax, double * nCmiValueHier, double * nCmiValueMax, 
			 int * iAdlSum, int * iCpsCode, char * sRugsVersion, char * sDllVersion, 
			 int * iError )
#else

extern "C" __declspec(dllexport) int __stdcall 
RugCalc( char * sMdsRecord, char * sRehabType, char * sModel, int iQuarterlyFlag, 
			 double nCmiArray[], char * sRugHier, char * sRugMax, int * iRugHier,
			 int * iRugMax, double * nCmiValueHier, double * nCmiValueMax, 
			 int * iAdlSum, int * iCpsCode, char * sRugsVersion, char * sDllVersion, 
			 int * iError )
#endif
//RUG-III Version 5.20 calculation routine
{
   char m_aa8b[5],m_b1[5],m_b2a[5],m_b4[5],m_c4[5],m_e1a[5],m_e1b[5],m_e1c[5],m_e1d[5],m_e1e[5];
   char m_e1f[5],m_e1g[5],m_e1h[5],m_e1i[5],m_e1j[5],m_e1k[5],m_e1l[5],m_e1m[5],m_e1n[5],m_e1o[5];
   char m_e1p[5],m_e4aa[5],m_e4ba[5],m_e4ca[5],m_e4da[5],m_e4ea[5],m_g1aa[5],m_g1ab[5],m_g1ba[5],m_g1bb[5];
   char m_g1ha[5],m_g1ia[5],m_g1ib[5],m_h3a[5],m_h3b[5],m_i1a[5],m_i1r[5],m_i1s[5],m_i1v[5],m_i1w[5];
   char m_i1z[5],m_i2e[5],m_i2g[5],m_j1c[5],m_j1e[5],m_j1h[5],m_j1i[5],m_j1j[5],m_j1o[5],m_k3a[5];
   char m_k5a[5],m_k5b[5],m_k6a[5],m_k6b[5],m_m1a[5],m_m1b[5],m_m1c[5],m_m1d[5],m_m2a[5],m_m4b[5];
   char m_m4c[5],m_m4g[5],m_m5a[5],m_m5b[5],m_m5c[5],m_m5d[5],m_m5e[5],m_m5f[5],m_m5g[5],m_m5h[5];
   char m_m6b[5],m_m6c[5],m_m6f[5],m_n1a[5],m_n1b[5],m_n1c[5],m_o3[5],m_p1aa[5],m_p1ab[5],m_p1ac[5];
   char m_p1ag[5],m_p1ah[5],m_p1ai[5],m_p1aj[5],m_p1ak[5],m_p1al[5],m_p1baa[5],m_p1bab[5],m_p1bba[5],m_p1bbb[5];
   char m_p1bca[5],m_p1bcb[5],m_p1bda[5],m_p3a[5],m_p3b[5],m_p3c[5],m_p3d[5],m_p3e[5],m_p3f[5],m_p3g[5];
   char m_p3h[5],m_p3i[5],m_p3j[5],m_p7[5],m_p8[5],m_t1b[5],m_t1c[5],m_t1d[5];
   char sAa8a[3], sAa8b[2], upperRehabType[10];
   int n_reh_u,n_reh_v,n_reh_h,n_reh_m,n_reh_l,n_ext,n_spec,n_clin,n_impair,n_behav,n_th_min;
   int n_th_ty3,n_th_ty5,n_th_day,n_nrsum6,n_nrsum2,n_depres,n_ext_ct;
   int n_bedmb,n_trans,n_toilt,n_intake,n_eatng,n_t1c,n_t1d,n_ulcer,n_sk_tr,n_n_awak,n_coma;
   int n_p7,n_p8,n_mood,n_cog1,n_cog2;
   int rangeCheck, bProcess, i, strlength;

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                                    
 *Step I.  Initialize variables, check input parameters, check MDS record type, load MDS items.                                       
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */                                    
   //Initialize outputs 
   strcpy( sRugHier, "BC1" );
   strcpy( sRugMax, "BC1" );
   *iRugHier = 58;
   *iRugMax = 58;
   if ( strcmp( sModel, "34" ) == 0 ) 
        strcpy( sRugsVersion, "08" ); 
   else if ( strcmp( sModel, "44" ) == 0 ) 
        strcpy( sRugsVersion, "07" ); 
   else if ( strcmp( sModel, "53" ) == 0 ) 
        strcpy( sRugsVersion, "09" ); 
   else
	    strcpy( sRugsVersion, "" );
   strcpy( sDllVersion, "1.00" );

   //Convert sRehabType to upper case
   strlength = (int)strlen( sRehabType );
   for ( i=0; i<strlength; i++ ) upperRehabType[i] = toupper( sRehabType[i] );
   upperRehabType[strlength] = '\0';
   
   //Check for parameter errors
   *iError = 0;
   if ( strcmp( upperRehabType, "MCARE" )!=0 && strcmp( upperRehabType, "OTHER" )!=0 ) {
	    *iError = 1;
		return 1;
   }
   if ( strcmp( sModel, "34" )!=0 && strcmp( sModel, "44" )!=0 && strcmp( sModel, "53" )!=0 ) {
	    *iError = 2;
		return 1;
   }
   if ( iQuarterlyFlag!=0 && iQuarterlyFlag!=1 ) {
        *iError = 3;
		return 1;
   }

   //Check type of MDS record
   LoadValue( sMdsRecord, 259, 2, sAa8a );
   LoadValue( sMdsRecord, 261, 1, sAa8b );
   bProcess = 0;
   //Only process data record (Rec_Id = "B0") or modification record (Rec_Id = "M0")
   if ( (sMdsRecord[0]=='B' || sMdsRecord[0]=='M') && sMdsRecord[1]=='0' ) {
         //Process full assessment
         if ( strcmp(sAa8a,"01")==0 || strcmp(sAa8a,"02")==0 || strcmp(sAa8a,"03")==0 || 
	          strcmp(sAa8a,"04")==0 ) 
	          bProcess = 1;
         //Process quarterly assessment if QuarterlyFlag = 1 (request to process quarterlies);
         else if ( (strcmp(sAa8a,"05")==0 || strcmp(sAa8a,"10")==0) && iQuarterlyFlag==1 )
              bProcess = 1;
         //Process PPS assessment;
         else if ( sAa8b[0]=='1' || sAa8b[0]=='2' || sAa8b[0]=='3' || sAa8b[0]=='4' || 
                   sAa8b[0]=='5' || sAa8b[0]=='7' || sAa8b[0]=='8' )
		      bProcess = 1;
         //Process other state-required assessment;
         else if ( strcmp(sAa8a,"00")==0 && sAa8b[0]=='6' )
              bProcess = 1;
         //Process other assessment;
         else if ( strcmp(sAa8a,"00")==0 && sAa8b[0]==' ' )
              bProcess = 1;
   }
   if ( !bProcess ) {
	    *iError = 4;
        //All output string parameters except sDllVersion should be blank and 
        //all output numeric parameters should be 0;
        strcpy( sRugHier, "   " );
        strcpy( sRugMax, "   " );
        *iRugHier = 0;
        *iRugMax = 0;
        *nCmiValueHier = 0;
		*nCmiValueMax = 0;
		*iAdlSum = 0;
		*iCpsCode = 0;
		strcpy( sRugsVersion, "  " );
		return 1;
   }

   //Check for invalid CMI element
   for ( i=0; i<59; i++ ) {
	     if ( nCmiArray[i] <= -9999 ) {
			  *iError = 5;
			  return 1;
		 }
   }

   //Load MDS RUG items into array
   LoadValue( sMdsRecord, 261, 1, masItemVal[0] );
   LoadValue( sMdsRecord, 417, 1, masItemVal[1] );
   LoadValue( sMdsRecord, 418, 1, masItemVal[2] );
   LoadValue( sMdsRecord, 425, 1, masItemVal[3] );
   LoadValue( sMdsRecord, 445, 1, masItemVal[4] );
   LoadValue( sMdsRecord, 454, 1, masItemVal[5] );
   LoadValue( sMdsRecord, 455, 1, masItemVal[6] );
   LoadValue( sMdsRecord, 456, 1, masItemVal[7] );
   LoadValue( sMdsRecord, 457, 1, masItemVal[8] );
   LoadValue( sMdsRecord, 458, 1, masItemVal[9] );
   LoadValue( sMdsRecord, 459, 1, masItemVal[10] );
   LoadValue( sMdsRecord, 460, 1, masItemVal[11] );
   LoadValue( sMdsRecord, 461, 1, masItemVal[12] );
   LoadValue( sMdsRecord, 462, 1, masItemVal[13] );
   LoadValue( sMdsRecord, 463, 1, masItemVal[14] );
   LoadValue( sMdsRecord, 464, 1, masItemVal[15] );
   LoadValue( sMdsRecord, 465, 1, masItemVal[16] );
   LoadValue( sMdsRecord, 466, 1, masItemVal[17] );
   LoadValue( sMdsRecord, 467, 1, masItemVal[18] );
   LoadValue( sMdsRecord, 468, 1, masItemVal[19] );
   LoadValue( sMdsRecord, 469, 1, masItemVal[20] );
   LoadValue( sMdsRecord, 472, 1, masItemVal[21] );
   LoadValue( sMdsRecord, 474, 1, masItemVal[22] );
   LoadValue( sMdsRecord, 476, 1, masItemVal[23] );
   LoadValue( sMdsRecord, 478, 1, masItemVal[24] );
   LoadValue( sMdsRecord, 480, 1, masItemVal[25] );
   LoadValue( sMdsRecord, 502, 1, masItemVal[26] );
   LoadValue( sMdsRecord, 503, 1, masItemVal[27] );
   LoadValue( sMdsRecord, 504, 1, masItemVal[28] );
   LoadValue( sMdsRecord, 505, 1, masItemVal[29] );
   LoadValue( sMdsRecord, 516, 1, masItemVal[30] );
   LoadValue( sMdsRecord, 518, 1, masItemVal[31] );
   LoadValue( sMdsRecord, 519, 1, masItemVal[32] );
   LoadValue( sMdsRecord, 563, 1, masItemVal[33] );
   LoadValue( sMdsRecord, 564, 1, masItemVal[34] );
   LoadValue( sMdsRecord, 574, 1, masItemVal[35] );
   LoadValue( sMdsRecord, 591, 1, masItemVal[36] );
   LoadValue( sMdsRecord, 592, 1, masItemVal[37] );
   LoadValue( sMdsRecord, 595, 1, masItemVal[38] );
   LoadValue( sMdsRecord, 596, 1, masItemVal[39] );
   LoadValue( sMdsRecord, 599, 1, masItemVal[40] );
   LoadValue( sMdsRecord, 622, 1, masItemVal[41] );
   LoadValue( sMdsRecord, 624, 1, masItemVal[42] );
   LoadValue( sMdsRecord, 668, 1, masItemVal[43] );
   LoadValue( sMdsRecord, 670, 1, masItemVal[44] );
   LoadValue( sMdsRecord, 673, 1, masItemVal[45] );
   LoadValue( sMdsRecord, 674, 1, masItemVal[46] );
   LoadValue( sMdsRecord, 675, 1, masItemVal[47] );
   LoadValue( sMdsRecord, 680, 1, masItemVal[48] );
   LoadValue( sMdsRecord, 712, 1, masItemVal[49] );
   LoadValue( sMdsRecord, 718, 1, masItemVal[50] );
   LoadValue( sMdsRecord, 719, 1, masItemVal[51] );
   LoadValue( sMdsRecord, 727, 1, masItemVal[52] );
   LoadValue( sMdsRecord, 728, 1, masItemVal[53] );
   LoadValue( sMdsRecord, 736, 1, masItemVal[54] );
   LoadValue( sMdsRecord, 737, 1, masItemVal[55] );
   LoadValue( sMdsRecord, 738, 1, masItemVal[56] );
   LoadValue( sMdsRecord, 739, 1, masItemVal[57] );
   LoadValue( sMdsRecord, 740, 1, masItemVal[58] );
   LoadValue( sMdsRecord, 744, 1, masItemVal[59] );
   LoadValue( sMdsRecord, 745, 1, masItemVal[60] );
   LoadValue( sMdsRecord, 749, 1, masItemVal[61] );
   LoadValue( sMdsRecord, 751, 1, masItemVal[62] );
   LoadValue( sMdsRecord, 752, 1, masItemVal[63] );
   LoadValue( sMdsRecord, 753, 1, masItemVal[64] );
   LoadValue( sMdsRecord, 754, 1, masItemVal[65] );
   LoadValue( sMdsRecord, 755, 1, masItemVal[66] );
   LoadValue( sMdsRecord, 756, 1, masItemVal[67] );
   LoadValue( sMdsRecord, 757, 1, masItemVal[68] );
   LoadValue( sMdsRecord, 758, 1, masItemVal[69] );
   LoadValue( sMdsRecord, 762, 1, masItemVal[70] );
   LoadValue( sMdsRecord, 763, 1, masItemVal[71] );
   LoadValue( sMdsRecord, 766, 1, masItemVal[72] );
   LoadValue( sMdsRecord, 768, 1, masItemVal[73] );
   LoadValue( sMdsRecord, 769, 1, masItemVal[74] );
   LoadValue( sMdsRecord, 770, 1, masItemVal[75] );
   LoadValue( sMdsRecord, 796, 1, masItemVal[76] );
   LoadValue( sMdsRecord, 802, 1, masItemVal[77] );
   LoadValue( sMdsRecord, 803, 1, masItemVal[78] );
   LoadValue( sMdsRecord, 804, 1, masItemVal[79] );
   LoadValue( sMdsRecord, 808, 1, masItemVal[80] );
   LoadValue( sMdsRecord, 809, 1, masItemVal[81] );
   LoadValue( sMdsRecord, 810, 1, masItemVal[82] );
   LoadValue( sMdsRecord, 811, 1, masItemVal[83] );
   LoadValue( sMdsRecord, 812, 1, masItemVal[84] );
   LoadValue( sMdsRecord, 813, 1, masItemVal[85] );
   LoadValue( sMdsRecord, 821, 1, masItemVal[86] );
   LoadValue( sMdsRecord, 822, 4, masItemVal[87] );
   LoadValue( sMdsRecord, 826, 1, masItemVal[88] );
   LoadValue( sMdsRecord, 827, 4, masItemVal[89] );
   LoadValue( sMdsRecord, 831, 1, masItemVal[90] );
   LoadValue( sMdsRecord, 832, 4, masItemVal[91] );
   LoadValue( sMdsRecord, 836, 1, masItemVal[92] );
   LoadValue( sMdsRecord, 852, 1, masItemVal[93] );
   LoadValue( sMdsRecord, 853, 1, masItemVal[94] );
   LoadValue( sMdsRecord, 854, 1, masItemVal[95] );
   LoadValue( sMdsRecord, 855, 1, masItemVal[96] );
   LoadValue( sMdsRecord, 856, 1, masItemVal[97] );
   LoadValue( sMdsRecord, 857, 1, masItemVal[98] );
   LoadValue( sMdsRecord, 858, 1, masItemVal[99] );
   LoadValue( sMdsRecord, 859, 1, masItemVal[100] );
   LoadValue( sMdsRecord, 860, 1, masItemVal[101] );
   LoadValue( sMdsRecord, 861, 1, masItemVal[102] );
   LoadValue( sMdsRecord, 872, 2, masItemVal[103] );
   LoadValue( sMdsRecord, 874, 2, masItemVal[104] );
   LoadValue( sMdsRecord, 1207, 1, masItemVal[105] );
   LoadValue( sMdsRecord, 1208, 2, masItemVal[106] );
   LoadValue( sMdsRecord, 1210, 4, masItemVal[107] );

   //Copy MDS RUG items into variables with m_ prefix
   strcpy( m_aa8b, masItemVal[0] ); 
   strcpy( m_b1, masItemVal[1] );
   strcpy( m_b2a, masItemVal[2] );
   strcpy( m_b4, masItemVal[3] );
   strcpy( m_c4, masItemVal[4] );
   strcpy( m_e1a, masItemVal[5] );
   strcpy( m_e1b, masItemVal[6] );
   strcpy( m_e1c, masItemVal[7] );
   strcpy( m_e1d, masItemVal[8] );
   strcpy( m_e1e, masItemVal[9] );
   strcpy( m_e1f, masItemVal[10] );
   strcpy( m_e1g, masItemVal[11] );
   strcpy( m_e1h, masItemVal[12] );
   strcpy( m_e1i, masItemVal[13] );
   strcpy( m_e1j, masItemVal[14] );
   strcpy( m_e1k, masItemVal[15] );
   strcpy( m_e1l, masItemVal[16] );
   strcpy( m_e1m, masItemVal[17] );
   strcpy( m_e1n, masItemVal[18] );
   strcpy( m_e1o, masItemVal[19] );
   strcpy( m_e1p, masItemVal[20] );
   strcpy( m_e4aa, masItemVal[21] );
   strcpy( m_e4ba, masItemVal[22] );
   strcpy( m_e4ca, masItemVal[23] );
   strcpy( m_e4da, masItemVal[24] );
   strcpy( m_e4ea, masItemVal[25] );
   strcpy( m_g1aa, masItemVal[26] );
   strcpy( m_g1ab, masItemVal[27] );
   strcpy( m_g1ba, masItemVal[28] );
   strcpy( m_g1bb, masItemVal[29] );
   strcpy( m_g1ha, masItemVal[30] );
   strcpy( m_g1ia, masItemVal[31] );
   strcpy( m_g1ib, masItemVal[32] );
   strcpy( m_h3a, masItemVal[33] );
   strcpy( m_h3b, masItemVal[34] );
   strcpy( m_i1a, masItemVal[35] );
   strcpy( m_i1r, masItemVal[36] );
   strcpy( m_i1s, masItemVal[37] );
   strcpy( m_i1v, masItemVal[38] );
   strcpy( m_i1w, masItemVal[39] );
   strcpy( m_i1z, masItemVal[40] );
   strcpy( m_i2e, masItemVal[41] );
   strcpy( m_i2g, masItemVal[42] );
   strcpy( m_j1c, masItemVal[43] );
   strcpy( m_j1e, masItemVal[44] );
   strcpy( m_j1h, masItemVal[45] );
   strcpy( m_j1i, masItemVal[46] );
   strcpy( m_j1j, masItemVal[47] );
   strcpy( m_j1o, masItemVal[48] );
   strcpy( m_k3a, masItemVal[49] );
   strcpy( m_k5a, masItemVal[50] );
   strcpy( m_k5b, masItemVal[51] );
   strcpy( m_k6a, masItemVal[52] );
   strcpy( m_k6b, masItemVal[53] );
   strcpy( m_m1a, masItemVal[54] );
   strcpy( m_m1b, masItemVal[55] );
   strcpy( m_m1c, masItemVal[56] );
   strcpy( m_m1d, masItemVal[57] );
   strcpy( m_m2a, masItemVal[58] );
   strcpy( m_m4b, masItemVal[59] );
   strcpy( m_m4c, masItemVal[60] );
   strcpy( m_m4g, masItemVal[61] );
   strcpy( m_m5a, masItemVal[62] );
   strcpy( m_m5b, masItemVal[63] );
   strcpy( m_m5c, masItemVal[64] );
   strcpy( m_m5d, masItemVal[65] );
   strcpy( m_m5e, masItemVal[66] );
   strcpy( m_m5f, masItemVal[67] );
   strcpy( m_m5g, masItemVal[68] );
   strcpy( m_m5h, masItemVal[69] );
   strcpy( m_m6b, masItemVal[70] );
   strcpy( m_m6c, masItemVal[71] );
   strcpy( m_m6f, masItemVal[72] );
   strcpy( m_n1a, masItemVal[73] );
   strcpy( m_n1b, masItemVal[74] );
   strcpy( m_n1c, masItemVal[75] );
   strcpy( m_o3, masItemVal[76] );
   strcpy( m_p1aa, masItemVal[77] );
   strcpy( m_p1ab, masItemVal[78] );
   strcpy( m_p1ac, masItemVal[79] );
   strcpy( m_p1ag, masItemVal[80] );
   strcpy( m_p1ah, masItemVal[81] );
   strcpy( m_p1ai, masItemVal[82] );
   strcpy( m_p1aj, masItemVal[83] );
   strcpy( m_p1ak, masItemVal[84] );
   strcpy( m_p1al, masItemVal[85] );
   strcpy( m_p1baa, masItemVal[86] );
   strcpy( m_p1bab, masItemVal[87] );
   strcpy( m_p1bba, masItemVal[88] );
   strcpy( m_p1bbb, masItemVal[89] );
   strcpy( m_p1bca, masItemVal[90] );
   strcpy( m_p1bcb, masItemVal[91] );
   strcpy( m_p1bda, masItemVal[92] );
   strcpy( m_p3a, masItemVal[93] );
   strcpy( m_p3b, masItemVal[94] );
   strcpy( m_p3c, masItemVal[95] );
   strcpy( m_p3d, masItemVal[96] );
   strcpy( m_p3e, masItemVal[97] );
   strcpy( m_p3f, masItemVal[98] );
   strcpy( m_p3g, masItemVal[99] );
   strcpy( m_p3h, masItemVal[100] );
   strcpy( m_p3i, masItemVal[101] );
   strcpy( m_p3j, masItemVal[102] );
   strcpy( m_p7, masItemVal[103] );
   strcpy( m_p8, masItemVal[104] );
   strcpy( m_t1b, masItemVal[105] );
   strcpy( m_t1c, masItemVal[106] );
   strcpy( m_t1d, masItemVal[107] );

   //Initialize intermediate variables
   n_reh_u  = 0;
   n_reh_v  = 0;
   n_reh_h  = 0;
   n_reh_m  = 0;
   n_reh_l  = 0;
   n_ext    = 0;
   n_spec   = 0;
   n_clin   = 0;
   n_impair = 0;
   n_behav  = 0;
   *iAdlSum = 0;
   n_th_min = 0;
   n_th_ty3 = 0;
   n_th_ty5 = 0;
   n_th_day = 0;
   n_nrsum6 = 0;
   n_nrsum2 = 0;
   n_depres = 0;
   *iCpsCode    = 0;
   n_ext_ct = 0;
  
   //Check ranges on MDS RUG-III items
   rangeCheck = LoadRange();
   if ( rangeCheck ) {
		return rangeCheck;
   }

 /*Initialize output CMIs to large negative number for hierarchical result     
  *group and index maximized result group                                   
  *n_cmi_hr is the CMI for the resulting hierarchical group */                   
   *nCmiValueHier = -9999; 
 //n_cmi_mx is the CMI for the resulting index maximized group.              
   *nCmiValueMax = -9999;
 /*NOTE:  In this code, a initial value of 9999 for n_cmi_mx is used to       
  *   indicate that neither index maximizing nor hierarchical classification  
  *   has been made yet                                                        
  *NOTE:  No CMI value can be <= -9999 or this code will not work properly for 
  *   both index maximizing and hierarchical classification */                    


//Begin calculation

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
 *Step II. Calculate RUG-III ADL Index.                                       
 *         The ADL index is required for use in splitting the Rehabilitation, 
 *            Special Care, Clinically Complex, Impaired Cognition, Behavior  
 *            Problems, and Reduced Physical Function RUG-III clinical        
 *            categories.  The ADL index requires scoring conversion for      
 *            4 different ADL's and then summation.                           
 *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 //ADL scoring conversion for Bed mobility                                    
   if ( m_g1aa[0]=='-' || m_g1aa[0]=='0' || m_g1aa[0]=='1' ) n_bedmb = 1;
   else if ( m_g1aa[0]=='2' ) n_bedmb = 3;
   else if ( m_g1aa[0]=='3' || m_g1aa[0]=='4' || m_g1aa[0]=='8' ) {
      if ( m_g1ab[0]=='-' || m_g1ab[0]=='0' || m_g1ab[0]=='1' || m_g1ab[0]=='2' ) n_bedmb = 4;
	  else if ( m_g1ab[0]=='3' || m_g1ab[0]=='8' ) n_bedmb = 5;
   }
 //ADL scoring conversion for Transfer                                        
   if ( m_g1ba[0]=='-' || m_g1ba[0]=='0' || m_g1ba[0]=='1' ) n_trans = 1;
   else if ( m_g1ba[0]=='2' ) n_trans = 3;
   else if ( m_g1ba[0]=='3' || m_g1ba[0]=='4' || m_g1ba[0]=='8' ) {
        if ( m_g1bb[0]=='-' || m_g1bb[0]=='0' || m_g1bb[0]=='1' || m_g1bb[0]=='2' ) n_trans = 4;
	    else if ( m_g1bb[0]=='3' || m_g1bb[0]=='8' ) n_trans = 5;
   }
 //ADL scoring conversion for Toilet Use                                     
   if ( m_g1ia[0]=='-' || m_g1ia[0]=='0' || m_g1ia[0]=='1' ) n_toilt = 1;
   else if ( m_g1ia[0]=='2' ) n_toilt = 3;
   else if ( m_g1ia[0]=='3' || m_g1ia[0]=='4' || m_g1ia[0]=='8' ) {
        if ( m_g1ib[0]=='-' || m_g1ib[0]=='0' || m_g1ib[0]=='1' || m_g1ib[0]=='2' ) n_toilt = 4;
	    else if ( m_g1ib[0]=='3' || m_g1ib[0]=='8' ) n_toilt = 5;
   }
 /*-------------------------------                                             
  *Code parenteral\enteral intake level--used for Eating scoring conversion and
  *later for Special Care and Clinically Complex qualification.                
  *   n_intake = 1 if (1) 51% or more of total calories are received           
  *              through parenteral/enteral intake (k6a) or (2) 26% to 50%   
  *              of total calories received through parenteral/enteral       
  *              intake (k6a) and fluid intake is 501 or more cc per day k6b).                                                      
  *   n_intake = 0 if parenteral/enteral intake is at a lower level (including 
  *              none).                                                       */
   n_intake = 0;
   if ( m_k6a[0]=='3' || m_k6a[0]=='4' ) n_intake = 1;
   else if ( m_k6a[0]=='2' && (m_k6b[0]=='2' || m_k6b[0]=='3' || m_k6b[0]=='4' || m_k6b[0]=='5') )
        n_intake = 1;
 //ADL scoring conversion for Eating                                           
   if ( m_k5a[0]=='1' || ( m_k5b[0]=='1' && n_intake==1 ) ) n_eatng = 3;
   else if ( m_g1ha[0]=='-' || m_g1ha[0]=='0' || m_g1ha[0]=='1' ) n_eatng = 1;
   else if ( m_g1ha[0]=='2' ) n_eatng = 2;
   else if ( m_g1ha[0]=='3' || m_g1ha[0]=='4' || m_g1ha[0]=='8' ) n_eatng = 3;
 //Sum the converted ADL scores to n_iAdlSum                                   
   *iAdlSum = n_bedmb + n_trans + n_toilt + n_eatng;

 /*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++       
  *Step III. Determine Rehab and Rehab nursing variables needed for            
  *          Rehab categories.                                               
  *          Variables needed to determine Rehab clinical hierarchy            
  *          qualification for Standard rehab classification:                
  *             - Total minutes of rehab therapy received (n_th_min)           
  *             - Total number of days of rehab received (n_th_day)            
  *             - Number of types of rehab therapy (n_th_ty3) received         
  *               at 3+ days each                                           
  *             - Number of types of rehab therapy (n_th_ty5) received         
  *               at 5+ days each                                           
  *             - Number of types of nursing rehab activities (n_nrsum6) at    
  *               6+ days each  (Note that n_nrsum6 includes any            
  *               scheduled toileting plan or bladder retraining program    
  *               as a component.)                                          
  *          Additional variable needed to determine Rehab clinical hierarchy  
  *          qualification for Special Medicare rehab classification:        
  *             - Number of types of nursing rehab activities (n_nrsum2) at    
  *               2+ days each  (Note that n_nrsum2 includes any            
  *               scheduled toileting plan or bladder retraining program    
  *               as a component.)                                          
  *             - Numeric versions of expected days (t1c) and expected         
  *               minutes (t1d) of rehab therapy.                           
  *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */      
 //Determine n_th_min -- the number of minutes of rehab therapy received.      
   n_th_min = 0;
   //Add speech therapy minutes unless dash filled (value '----') 
   if ( strcmp( m_p1bab, "----" )!= 0 ) n_th_min += atoi( m_p1bab );
   //Add occupational therapy minutes unless dash filled (value '----')          
   if ( strcmp( m_p1bbb, "----" )!= 0 ) n_th_min += atoi( m_p1bbb );
   //Add physical therapy minutes unless dash filled (value '----')              
   if ( strcmp( m_p1bcb, "----" )!= 0 ) n_th_min += atoi( m_p1bcb );
 //Determine n_th_day -- the number of days of rehab therapy received.         
   n_th_day = 0;
   //Add speech therapy days if in valid numeric range                           
   if ( '1'<=m_p1baa[0] && m_p1baa[0]<='7' ) n_th_day += atoi( m_p1baa );
   //Add occupational therapy days if in valid numeric range                     
   if ( '1'<=m_p1bba[0] && m_p1bba[0]<='7' ) n_th_day += atoi( m_p1bba );
   //Add physical therapy days if in valid numeric range                        
   if ( '1'<=m_p1bca[0] && m_p1bca[0]<='7' ) n_th_day += atoi( m_p1bca );
 //Determine n_th_ty3.                                                         
 //n_th_ty3 represents the number of different rehab therapies that         
 //were provided on 3 or more days during that period. It is used           
 //to determine qualification for Ultra High intensity rehab.              
   n_th_ty3 = 0;
   if ( '3'<=m_p1baa[0] && m_p1baa[0]<='7' ) n_th_ty3++;
   if ( '3'<=m_p1bba[0] && m_p1bba[0]<='7' ) n_th_ty3++;
   if ( '3'<=m_p1bca[0] && m_p1bca[0]<='7' ) n_th_ty3++;
 //Determine n_th_ty5.                                                         
 //n_th_ty5 represents the number of different rehab therapies that         
 //were provided on 5 or more days during that period. It is used           
 //to determine qualification for Ultra High, Very High and High            
 //intensity rehab.                                                         
   n_th_ty5 = 0;
   if ( '5'<=m_p1baa[0] && m_p1baa[0]<='7' ) n_th_ty5++;
   if ( '5'<=m_p1bba[0] && m_p1bba[0]<='7' ) n_th_ty5++;
   if ( '5'<=m_p1bca[0] && m_p1bca[0]<='7' ) n_th_ty5++;
 //Determine n_nrsum6.                                                         
 //n_nrsum6 is a count of the number of types of nursing rehab activities   
 //provided at least 6 days per week.  Note that a scheduled toileting      
 //plan or bladder retraining program is included in this count.            
   n_nrsum6 = 0;
 //Add 1 for passive range of motion (p3a) or active range of motion (p3b)    
   if ( ('6'<=m_p3a[0] && m_p3a[0]<='7') || ('6'<=m_p3b[0] && m_p3b[0]<='7') ) n_nrsum6++;
 //Add 1 for bed mobility (p3d) or walking (p3f) training                      
   if ( ('6'<=m_p3d[0] && m_p3d[0]<='7') || ('6'<=m_p3f[0] && m_p3f[0]<='7') ) n_nrsum6++;
 //Add 1 for splint or brace assistance (p3c)                                  
   if ( '6'<=m_p3c[0] && m_p3c[0]<='7' ) n_nrsum6++;
 //Add 1 for transfer training (p3e)                                           
   if ( '6'<=m_p3e[0] && m_p3e[0]<='7' ) n_nrsum6++;
 //Add 1 for dressing or grooming training (p3g)                               
   if ( '6'<=m_p3g[0] && m_p3g[0]<='7' ) n_nrsum6++;
 //Add 1 for eating or swallowing training (p3h)                               
   if ( '6'<=m_p3h[0] && m_p3h[0]<='7' ) n_nrsum6++;
 //Add 1 for amputation/prosthesis care (p3i)                                  
   if ( '6'<=m_p3i[0] && m_p3i[0]<='7' ) n_nrsum6++;
 //Add 1 for communication training (p3j)                                      
   if ( '6'<=m_p3j[0] && m_p3j[0]<='7' ) n_nrsum6++;
 //Add 1 for any scheduled toileting plan (h3a) or bladder retraining program (h3b)                                                           
   if ( m_h3a[0]=='1' || m_h3b[0]=='1' ) n_nrsum6++;
 //Determine n_nrsum2.                                                         
 //   n_nrsum2 is a count of the number of types of nursing rehab activities   
 //   provided at least 2 days per week.  Note that a scheduled toileting      
 //   plan or bladder retraining program is included in this count.            
   n_nrsum2 = 0;
 //Add 1 for passive range of motion (p3a) or active range of motion (p3b)    
   if ( ('2'<=m_p3a[0] && m_p3a[0]<='7') || ('2'<=m_p3b[0] && m_p3b[0]<='7') ) n_nrsum2++; 
 //Add 1 for bed mobility (p3d) or walking (p3f) training                     
   if ( ('2'<=m_p3d[0] && m_p3d[0]<='7') || ('2'<=m_p3f[0] && m_p3f[0]<='7') ) n_nrsum2++; 
 //Add 1 for splint or brace assistance (p3c)
   if ( '2'<=m_p3c[0] && m_p3c[0]<='7' ) n_nrsum2++;  
 //Add 1 for transfer training (p3e)                                           
   if ( '2'<=m_p3e[0] && m_p3e[0]<='7' ) n_nrsum2++;  
 //Add 1 for dressing or grooming training (p3g)                             
   if ( '2'<=m_p3g[0] && m_p3g[0]<='7' ) n_nrsum2++;  
 //Add 1 for eating or swallowing training (p3h)                              
   if ( '2'<=m_p3h[0] && m_p3h[0]<='7' ) n_nrsum2++;  
 //Add 1 for amputation/prosthesis care (p3i)                                 
   if ( '2'<=m_p3i[0] && m_p3i[0]<='7' ) n_nrsum2++;  
 //Add 1 for communication training (p3j)                                      
   if ( '2'<=m_p3j[0] && m_p3j[0]<='7' ) n_nrsum2++;  
 //Add 1 for any scheduled toileting plan (h3a) or bladder retraining program (h3b)                                                            
   if ( m_h3a[0]=='1' || m_h3b[0]=='1' ) n_nrsum2++;
 //Create n_t1c and n_t1d, numeric variables for expected days (t1c) and minutes (t1d) of rehab therapy.                                          ;
 //Set value of n_t1c to 0 if t1c is blank or dash filled (value  "--').      
   if ( strcmp( m_t1c, "  " )==0 || strcmp( m_t1c, "--" )==0 ) n_t1c = 0;
   else n_t1c = atoi( m_t1c );
 //Set value of n_t1d to 0 if t1dc is blank or dash filled (value  "----').   
   if ( strcmp( m_t1d, "    " )==0 || strcmp( m_t1d, "----" )==0 ) n_t1d = 0;
   else n_t1d = atoi( m_t1d );

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  *Step IV. Test Rehab category qualification.                                 
  *         Rehab categories are separated by several factors: Total minutes  
  *         of rehab therapy, number of types of therapy, and number of types 
  *         of nursing rehab activities.                                      
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 /*Determine qualification for Ultra High Rehab                                
  *Resident qualifies for Ultra High Intensity Rehab.                  
  *   Qualifications:                                                  
  *      (1) 720+ minutes received across all types (n_th_min)         
  *                AND                                                 
  *      (2) 5+ days received for 1 type of therapy (n_th_ty5)         
  *                AND                                                 
  *      (3) 3+ days received for a second type of                     
  *          therapy (n_th_ty3)  */                                        
   if ( n_th_min>=720 && n_th_ty5>=1 && n_th_ty3>=2 ) n_reh_u = 1;
 /*Determine qualification for Very High Rehab                                 
  *Resident qualifies for Very High Intensity Rehab.                   
  *   Qualifications:                                                  
  *      (1) 500+ minutes received across all types (n_th_min)         
  *                AND                                                 
  *      (2) 5+ days received for 1 type of therapy (n_th_ty5) */
   if ( n_th_min>=500 && n_th_ty5>=1 ) n_reh_v = 1;
 /*Determine qualification for High Rehab                                      
  *Resident qualifies for High Intensity Rehab.                       
  *      Qualifications:                                              
  *         (1) 325+ minutes received across all types (n_th_min)     
  *                   AND                                             
  *         (2) 5+ days received for 1 type of therapy (n_th_ty5)     
  *   If the resident does not meet these qualifications and          
  *   (1) the calculation method selected is Medicare (i.e., the      
  *   parameter sRehabType  "SMcare') and (2) the reason for             
  *   assessment involves a supplemental assessment type of           
  *   "5 day assessment" (AA8b  "1') OR "readmission assessment"     
  *   (AA8b  "5'), then the resident may qualify for High            
  *   Intensity Rehab under the following Special Medicare            
  *   Provisions.                                                     
  *      Qualifications under Special Medicare Provisions:            
  *         (1) Physician has ordered therapies (t1b)                 
  *                AND                                                
  *         (2) 65+ minutes received across all types (n_th_min)      
  *                AND                                                
  *         (3) 520+ minutes of expected therapy (t1d)                
  *                AND                                                
  *         (4) 8+ days of expected therapy (t1c)  */                     
   if ( n_th_min>=325 && n_th_ty5>=1 ) n_reh_h = 1;
   else if ( (m_aa8b[0]=='1' || m_aa8b[0]=='5') && strcmp(upperRehabType, "MCARE")==0 ) {
        if ( m_t1b[0]=='1' && n_th_min>=65 && n_t1d>=520 && (8<=n_t1c && n_t1c<=15) ) n_reh_h = 1;
   }
 /*Determine qualification for Medium Rehab                                    
  *Resident qualifies for Medium Rehab.                               
  *      Qualifications:                                              
  *         (1) 150+ minutes received across all types (n_th_min)     
  *                AND                                                
  *         (2) 5+ days received across all types of                  
  *             therapy (n_th_day)                                    
  *   If the resident does not meet these qualifications and          
  *   (1) the calculation method selected is Medicare (i.e., the      
  *   parameter sRehabType  "SMcare') and (2) the reason for             
  *   assessment involves a supplemental assessment type of           
  *   "5 day assessment" (AA8b  "1') OR "readmission assessment"     
  *   (AA8b  "5'), then the resident may qualify for Medium          
  *   Intensity Rehab under the following Special Medicare            
  *   Provisions.                                                     
  *      Qualifications under Special Medicare Provisions:            
  *         (1) Physician has ordered therapies (t1b)                 
  *                AND                                                
  *         (2) 240+ minutes of expected therapy (t1d)                
  *                AND                                                
  *         (3) 8+ days of expected therapy (t1c)  */                     
   if ( n_th_min>=150 &&  n_th_day>=5 ) n_reh_m = 1;
   else if ( (m_aa8b[0]=='1' || m_aa8b[0]=='5') && strcmp(upperRehabType, "MCARE")==0 ) {
        if ( m_t1b[0]=='1' && n_t1d>=240 && (8<=n_t1c && n_t1c<=15) ) n_reh_m = 1;
   }
 /*Determine qualification for Low Rehab                                       
  *Resident qualifies for Low Intensity Rehab.                        
  *      Qualifications:                                              
  *         (1) 45+ minutes received across all types (n_th_min)      
  *                AND                                                
  *         (2) 3+ days received across all types of                  
  *             therapy (n_th_day)                                    
  *                AND                                                
  *         (3) 2+ nursing rehab activities at 6+ days                
  *             each (n_nrsum6)                                       
  *                                                                   
  *   If the resident does not meet these qualifications and          
  *   (1) the calculation method selected is Medicare (i.e., the      
  *   parameter sRehabType  "SMcare') and (2) the reason for             
  *   assessment involves a supplemental assessment type of           
  *   "5 day assessment" (AA8b  "1') OR "readmission assessment"     
  *   (AA8b  "5'), then the resident may qualify for Low             
  *   Intensity Rehab under the following Special Medicare            
  *   Provisions.                                                     
  *      Qualifications under Special Medicare Provisions:            
  *         (1) Physician has ordered therapies (t1b)                 
  *                AND                                                
  *         (2) 75+ minutes of expected therapy (t1d)                 
  *                AND                                                
  *         (3) 5+ days of expected therapy (t1c)                     
  *         (4) 2+ nursing rehab activities at 2+ days                
  *             each (n_nrsum2)  */                                       
   if ( n_th_min>=45 && n_th_day>=3 && n_nrsum6>=2 ) n_reh_l = 1;
   else if ( (m_aa8b[0]=='1' || m_aa8b[0]=='5') && strcmp(upperRehabType, "MCARE")==0 ) {
        if ( m_t1b[0]=='1' && n_t1d>=75 && (5<=n_t1c && n_t1c<=15) && n_nrsum2>=2 ) n_reh_l = 1;
   }

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++          
  *Step V.  Test Extensive Care qualification.                                 
  *Determine qualification for Extensive Care.                                 
  *Check for required Extensive Care clinical indicators.                      
  *Resident qualifies for Extensive Care category on the basis of clinical  
  *indicators.                                                              
  *   Qualifications:                                                       
  *      Parenteral/IV feedings (k5a) OR IV medication (p1ac) OR            
  *      suctioning (p1ai) OR tracheostomy care (p1aj) OR                   
  *      ventilator or respirator (p1al).                                   
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
  if ( m_k5a[0]=='1' || m_p1ac[0]=='1' || m_p1ai[0]=='1' || m_p1aj[0]=='1' || m_p1al[0]=='1' ) n_ext = 1;

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++         
  *Step VI.  Test Special Care qualification.                                  
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
  //*Code count of all levels of ulcer (n_ulcer) for Special Care qualification                                                            
   n_ulcer = 0;
   if ( '1'<=m_m1a[0] && m_m1a[0]<='9' ) n_ulcer += atoi(  m_m1a );
   if ( '1'<=m_m1b[0] && m_m1b[0]<='9' ) n_ulcer += atoi(  m_m1b );
   if ( '1'<=m_m1c[0] && m_m1c[0]<='9' ) n_ulcer += atoi(  m_m1c );
   if ( '1'<=m_m1d[0] && m_m1d[0]<='9' ) n_ulcer += atoi(  m_m1d );
 /*Code count of selected skin care treatments for Special Care qualification */
   n_sk_tr = 0;
   if ( m_m5a[0]=='1' || m_m5b[0]=='1' ) n_sk_tr++;
   if ( m_m5c[0]=='1' ) n_sk_tr++;
   if ( m_m5d[0]=='1' ) n_sk_tr++;
   if ( m_m5e[0]=='1' ) n_sk_tr++;
   if ( m_m5g[0]=='1' ) n_sk_tr++;
   if ( m_m5h[0]=='1' ) n_sk_tr++;
 /*Check for required Special Care clinical indicators                         
  *Resident qualifies for Special Care category on the basis of       
  *clinical indicators.                                               
  *   Qualifications (any one sufficient):                            
  *      1. Two or more ulcers of any type (n_ulcer) OR stage 3       
  *         or 4 pressure ulcer (m2a)                                 
  *            AND                                                    
  *         two or more selected skin care treatments (n_sk_tr).      
  *      2. Feeding tube (k5b) WITH parenteral/enteral intake         
  *         (n_intake) AND aphasia (i1r).                             
  *      3. Surgical wounds (m4g) OR open lesions other than          
  *         ulcers, rashes, cuts (m4c)                                
  *            AND                                                    
  *         surgical wound care (m5f) OR application of               
  *         dressings (m5g) OR application of ointments (m5h).        
  *      4. Respiratory therapy for 7 days (p1bda).                   
  *      5. Cerebral palsy (i1s) AND ADL score of 10 or more          
  *         (n_iAdlSum).                                               
  *      6. Fever (j1h)                                               
  *            AND                                                    
  *         vomiting (j1o) OR weight loss (k3a) OR tube feeding       
  *         (k5b) WITH high parenteral/enteral intake (n_intake)      
  *         OR pneumonia (i2e) OR dehydrated (j1c).                   
  *      7. Multiple sclerosis (i1w) AND ADL score of 10 or more      
  *         (n_iAdlSum).                                               
  *      8. Quadriplegia (i1z) AND ADL score of 10 or more            
  *         (n_iAdlSum).                                               
  *      9. Radiation therapy (p1ah).  */                                 
   if ( ((n_ulcer>=2 || m_m2a[0]=='3' || m_m2a[0]=='4') && n_sk_tr>=2) ||  
	    ((m_k5b[0]=='1' && n_intake==1) && m_i1r[0]=='1') ||  
		((m_m4g[0]=='1' || m_m4c[0]=='1') && (m_m5f[0]=='1' || m_m5g[0]=='1' || m_m5h[0]=='1')) ||
		m_p1bda[0]=='7' || (m_i1s[0]=='1' && *iAdlSum>=10) || 
		(m_j1h[0]=='1' && (m_j1o[0]=='1' || m_k3a[0]=='1' || (m_k5b[0]=='1' && n_intake==1) || m_i2e[0]=='1' || m_j1c[0]=='1'))
        || (m_i1w[0]=='1' && *iAdlSum>=10) || (m_i1z[0]=='1' && *iAdlSum>=10) || m_p1ah[0]=='1' ) 
      n_spec = 1;

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++          
  *Step VII. Test Clinically Complex qualification.                            
  *Calculate the number of periods the resident is not awake (n_n_awak).       
  *   This variable is used in determining whether the resident is comatose    
  *   or not.  This calculation influences qualification for both Clinically   
  *   Complex and Cognitive Impairment.  This count (n_n_awak) is based on     
  *   items n1a, n1b, and n1c.  For RUG-III classification, it is assumed      
  *   that the resident is not awake, only if the response to an item is a     
  *   0 (zero).  If the response to an item is '-' (unknown), then it is       
  *   treated as if the resident were awake for that period.                    
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
   n_n_awak = 0;
   if ( m_n1a[0]=='0' ) n_n_awak++;
   if ( m_n1b[0]=='0' ) n_n_awak++;
   if ( m_n1c[0]=='0' ) n_n_awak++;
 /*Calculate n_coma indicating whether the resident is comatose with qualifiers
  *      n_coma = 1 if resident is comatose (b1 = 1) and not awake all three   
  *                 periods (n_n_awak = 3) and ADL dependent (g1aa, g1ba, g1ha,
  *                 and g1ia all have values of '4' or '8').                   
  *             = 0 otherwise. */                                                
   n_coma = 0;
   if ( m_b1[0]=='1' && n_n_awak==3 && (m_g1aa[0]=='4' || m_g1aa[0]=='8')&& 
	    (m_g1ba[0]=='4' || m_g1ba[0]=='8') && (m_g1ha[0]=='4' || m_g1ha[0]=='8') && 
	    (m_g1ia[0]=='4' || m_g1ia[0]=='8') ) n_coma = 1;
 /*Make numeric versions of p7 and p8 for ease of coding, setting value to 0   
  *   if item dash filled (value of '--').  */                                   
   n_p7 = 0;
   if ( strcmp(m_p7, "--")!=0 ) n_p7 = atoi( m_p7 );
   n_p8 = 0;
   if ( strcmp(m_p8, "--")!=0 ) n_p8 = atoi( m_p8 );
 /*Check for Clinically Complex qualification.                                
  *Resident qualifies for Clinically Complex category on the basis of 
  *clinical indicators.                                               
  *   Qualifications (any one sufficient):                            
  *      1. Feeding tube (k5b) WITH high parenteral/enteral           
  *         intake (n_intake).                                        
  *      2. Comatose (b1) AND not awake (n_n_awak) AND                
  *         ADL dependent (g1aa, g1ba, g1ha, g1ia).                   
  *      3. Septicemia (i2g).                                         
  *      4. Burns--second or third degree (m4b).                      
  *      5. Dehydration (j1c).                                        
  *      6. Hemiplegia/hemiparesis (i1v) and ADL score of             
  *         10 or more (n_iAdlSum).                                    
  *      7. Internal bleeding (j1j).                                  
  *      8. Pneumonia (i2e).                                          
  *      9. End stage disease (j5c).-removed from 5.12                
  *     10. Chemotherapy (p1aa).                                      
  *     11. Dialysis (p1ab).                                          
  *     12. Physician order changes (p8) on 4 or more days            
  *         AND physician visits (p7) on 1 or more days.              
  *     13. Physician order changes (p8) on 2 or more days            
  *         AND physician visits (p7) on 2 or more days.              
  *     14. Diabetes (i1a) AND injections (o3) on 7 days              
  *         AND physician order changes (p8) on 2 or more             
  *         days.                                                     
  *     15. Transfusions (p1ak).                                      
  *     16. Oxygen therapy (p1ag).                                    
  *     17. Infection on foot (m6b) OR open lesion on foot (m6c)      
  *            AND                                                    
  *         application of dressings to foot (m6f).  */               
   if ( (m_k5b[0]=='1' && n_intake==1) || n_coma==1 || m_i2g[0]=='1' ||
	     m_m4b[0]=='1' || m_j1c[0]=='1' || (m_i1v[0]=='1' && *iAdlSum>=10) ||
		 m_j1j[0]=='1' || m_i2e[0]=='1' || m_p1aa[0]=='1' || m_p1ab[0]=='1' ||  
		 ((4<=n_p8 && n_p8<=14) && (1<=n_p7 && n_p7<=14)) || 
		 ((2<=n_p8 && n_p8<=14) && (2<=n_p7 && n_p7<=14)) || 
		 (m_i1a[0]=='1' && m_o3[0]=='7' && (2<=n_p8 && n_p8 <= 14)) || 
		 m_p1ak[0]=='1' || m_p1ag[0]=='1' || ((m_m6b[0]=='1' || m_m6c[0]=='1') && (m_m6f[0]=='1' )) )
       n_clin = 1;

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  *Step VIII.  Determine depression variable (n_depres) needed                 
  *               for splitting the Clinically Complex Category.               
  *            n_depres is a depression flag indicating presence of            
  *               depression (value 1) or absence of depression (value 0).   
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
 //Determine count of depression indicators (n_mood)                           
   n_mood = 0;
   if ( m_e1a[0]=='1' || m_e1a[0]=='2' ) n_mood++;
   if ( m_e1b[0]=='1' || m_e1b[0]=='2' ) n_mood++;
   if ( m_e1c[0]=='1' || m_e1c[0]=='2' ) n_mood++;
   if ( m_e1d[0]=='1' || m_e1d[0]=='2' ) n_mood++;
   if ( m_e1e[0]=='1' || m_e1e[0]=='2' ) n_mood++;
   if ( m_e1f[0]=='1' || m_e1f[0]=='2' ) n_mood++;
   if ( m_e1g[0]=='1' || m_e1g[0]=='2' ) n_mood++;
   if ( m_e1h[0]=='1' || m_e1h[0]=='2' ) n_mood++;
   if ( m_e1i[0]=='1' || m_e1i[0]=='2' ) n_mood++;
   if ( m_e1j[0]=='1' || m_e1j[0]=='2' ) n_mood++;
   if ( m_e1k[0]=='1' || m_e1k[0]=='2' ) n_mood++;
   if ( m_e1l[0]=='1' || m_e1l[0]=='2' ) n_mood++;
   if ( m_e1m[0]=='1' || m_e1m[0]=='2' ) n_mood++;
   if ( m_e1n[0]=='1' || m_e1n[0]=='2' ) n_mood++;
   if ( m_e1o[0]=='1' || m_e1o[0]=='2' ) n_mood++;
   if ( m_e1p[0]=='1' || m_e1p[0]=='2' ) n_mood++;
 //Set depression flag (n_depres).                                            
   if ( n_mood >= 3 ) n_depres = 1;
   else n_depres = 0;

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  *Step IX. Test Cognitive Impairment qualification.                           
  *Note:  RUG-III Cognitive Impairment qualification is based on               
  *       the Cognitive Performance Scale.                                     
  *   Details concerning this scale are available in:                          
  *       Morris JN, Fries BE, Morris JN, Fries BE, Mehr DR, Hawes C,          
  *       Phillips C, Mor V, and Lipsitz LA.  "MDS Cognitive Performance       
  *       Scale" J. Gerontology: Medical Sciences 49(4):M174-M182 (July)       
  *       1994.                                                                
  *   For use in RUG-III classification, the Cognitive Performance             
  *   Scale logic has been modified to use the same qualifiers for             
  *   a comatose condition as used for Clinically Complex qualification.       
  *   Note that a previously calculated variable, n_coma, is used in the       
  *   Cognitive Performance Scale.                                             
  *      n_coma = 1 if resident is comatose (b1 = 1) and not awake             
  *                 (n_n_awak = 3) and ADL dependent (g1aa, g1ba, g1ha, and    
  *                 g1ia all have values of '4' or '8').                       
  *             = 0 otherwise.                                                 
  *Calculate n_cog1 and n_cog2 variables used in Cognitive Performance Scale.  
  *   n_cog1 is a count of non-independence on three items (b2a, b4, and c4). 
  *   n_cog2 is a count of moderate to severe impairment on two items (b4 and c4).                                                      
  *   Both n_cog1 and n_cog2 have default values of -1 (missing) and are       
  *   only calculated if item b2a is in the range 0 to 1, item b4 is in        
  *   the range 0 to 3, and item c4 is in the range 0 to 3. 
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
   n_cog1 = -1;
   n_cog2 = -1;
   if ( (m_b2a[0]>='0' && m_b2a[0]<='1') && (m_b4[0]>='0' && m_b4[0]<='3') 
	                                    && (m_c4[0]>='0' && m_c4[0]<='3') ) {
        n_cog1 = 0;
        if ( m_b2a[0]=='1' ) n_cog1++;
	    if ( m_b4[0]=='1' || m_b4[0]=='2' ) n_cog1++;
        if ( m_c4[0]=='1' || m_c4[0]=='2' || m_c4[0]=='3' ) n_cog1++;
        n_cog2 = 0;
        if ( m_b4[0]=='2' ) n_cog2++;
        if ( m_c4[0]=='2' || m_c4[0]=='3' ) n_cog2++;
   }
 /*Calculate n_cps--Cognitive Performance Scale .                              
  *   Cognitive Performance Scale Codes:                                       
  *          0 = intact                                                        
  *          1 = borderline intact                                             
  *          2 = mild impairment                                               
  *          3 = moderate impairment                                           
  *          4 = moderately severe impairment                                  
  *          5 = severe impairment                                             
  *          6 = very severe impairment                                        
  *Set n_cps to a default of 0 and calculate        */                         
   *iCpsCode = 0;
   if ( n_coma==1 && !( m_b4[0]=='0' || m_b4[0]=='1' || m_b4[0]=='2') ) *iCpsCode = 6;
   else if ( m_b4[0]=='3' ) {
       if ( m_g1ha[0]=='4' || m_g1ha[0]=='8' ) *iCpsCode = 6;
       else if ( m_g1ha[0]=='-' || m_g1ha[0]=='0' || m_g1ha[0]=='1'
                 || m_g1ha[0]=='2' || m_g1ha[0]=='3' ) *iCpsCode = 5;
   }
   else if ( n_cog1==2 || n_cog1==3 ) {
       if ( n_cog2==2 ) *iCpsCode = 4;
       else if ( n_cog2==1 ) *iCpsCode = 3;
       else if ( n_cog2==0 ) *iCpsCode = 2;
   }
   else if ( n_cog1==1 ) *iCpsCode = 1;
 //Determine Cognitive Impairment qualification.                             
 //Qualification if Cognitive Performance Scale is 3 or more.          
   if ( *iCpsCode >= 3 ) n_impair = 1;

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  *Step X. Test Behavior Problems qualification.                              
  *Check for Behavior Problems qualification.                                  
  *Behavior Problems Qualifications (any one sufficient):             
  *      1. Wandering occurred on 4 or more days (e4aa).              
  *      2. Verbally abusive behavior occurred on 4 or more           
  *         days (e4ba).                                              
  *      3. Physically abusive behavior occurred on 4 or              
  *         more days (e4ca).                                         
  *      4. Socially inappropriate/disruptive behavior                
  *         occurred on 4 or more days (e4da).                        
  *      5. Resident resisted care on 4 or more days (e4ea).          
  *      6. Hallucinations (j1i).                                     
  *      7. Delusions (j1e).  
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
   if ( (m_e4aa[0]=='2' || m_e4aa[0]=='3') || (m_e4ba[0]=='2' || m_e4ba[0]=='3') ||
	    (m_e4ca[0]=='2' || m_e4ca[0]=='3') || (m_e4da[0]=='2' || m_e4da[0]=='3') ||  
		(m_e4ea[0]=='2' || m_e4ea[0]=='3') || (m_j1i[0]=='1') || (m_j1e[0]=='1') )
        n_behav= 1;

 /*++++++++++++++++++++++++++++++++++++++++                                    
  *Step XI. Classify into RUG-III Groups                                       
  *++++++++++++++++++++++++++++++++++++++++                                    
  *NOTE:  n_cmi_mx is used to control both index maximizing and hierarchical   
  *   classification.  At this point n_cmi_mx is the initial value of 9999,   
  *   and this initial value indicates that neither index maximizing nor       
  *   hierarchical classification has been made yet.                           
  *Begin Classification into 53-group Rehab/Extensive Groups*****              
  *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
  if ( strcmp( sModel, "53" )==0 ) { 
       /* All final splits based on ADL sum (n_iAdlSum).                         
        *Classify into Ultra High Intensity Rehab Plus Extensive groups*****        
        *Classify if Ultra High Rehab and Extensive indicators present.           
        *Determine final splits for Ultra High Rehab Plus Extensive residents     
        *on the basis of ADL sum. */                                                
	    if ( n_reh_u==1 && (n_ext== 1 && *iAdlSum >=7) ) { 
			 if ( 16<=*iAdlSum && *iAdlSum<=18 ) {
				  if ( nCmiArray[1] > *nCmiValueMax ) {
					   if ( *nCmiValueMax == -9999 ) {
                            *nCmiValueHier = nCmiArray[1];
                            strcpy( sRugHier, "RUX" ); 
                            *iRugHier = 1;
					   }
                       *nCmiValueMax = nCmiArray[1];
                       strcpy( sRugMax, "RUX" );
                       *iRugMax = 1;
				  }
			 }
			 else if ( 7<=*iAdlSum && *iAdlSum<=15 ) {
				  if ( nCmiArray[2] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) { 
                           *nCmiValueHier = nCmiArray[2];
                           strcpy( sRugHier, "RUL" ); 
                           *iRugHier = 2;
					  }
                      *nCmiValueMax = nCmiArray[2];
                      strcpy( sRugMax, "RUL" );
                      *iRugMax = 2;
				  }
			 }
		}
        /*Classify into Very High Intensity Rehab Plus Extensive groups*****        
         *   Classify if Very High Rehab and Extensive indicators present and         
         *      (1) a previous hierarchical classification has not been made          
         *          (indicated by n_cmi_mx being at a default negative value)         
         *   or (2) yields a higher rate for index maximization.                      
         *   Determine final splits for Very High Rehab Plus Extensive residents      
         *   on the basis of ADL sum.  Accept classification into a group if CMI      
         *   for that group is higher than previous high CMI.  */                         
		if ( n_reh_v==1 && (n_ext==1 && *iAdlSum>=7) ) { 
			 if ( 16<=*iAdlSum && *iAdlSum<=18 ) {
				  if ( nCmiArray[3] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) { 
                            *nCmiValueHier = nCmiArray[3];
                            strcpy( sRugHier, "RVX" ); 
                            *iRugHier = 3;
					   }
                       *nCmiValueMax = nCmiArray[3];
                       strcpy( sRugMax, "RVX" );
                       *iRugMax = 3;
				  }
			 }
			 else if ( 7<=*iAdlSum && *iAdlSum<=15 ) {
				  if ( nCmiArray[4] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) { 
                            *nCmiValueHier = nCmiArray[4];
                            strcpy( sRugHier, "RVL" ); 
                            *iRugHier = 4;
					   }
                       *nCmiValueMax = nCmiArray[4];
                       strcpy( sRugMax, "RVL" );
                       *iRugMax = 4;
				  }
			 }
		}
        /*Classify into High Intensity Rehab Plus Extensive groups*****            
        *   Classify if High Rehab and Extensive indicators present and              
        *      (1) a previous hierarchical classification has not been made          
        *          (indicated by n_cmi_mx being at a default negative value)         
        *   or (2) yields a higher rate for index maximization.                      
        *   Determine final splits for High Rehab Plus Extensive residents           
        *   on the basis of ADL sum.  Accept classification into a group if CMI      
        *   for that group is higher than previous high CMI. */
		if ( n_reh_h==1 && (n_ext==1 && *iAdlSum >=7) ) {
			 if ( 13<=*iAdlSum && *iAdlSum<=18 ) {
				  if ( nCmiArray[5] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) {
                            *nCmiValueHier = nCmiArray[5];
                            strcpy( sRugHier, "RHX" ); 
                            *iRugHier = 5;
					   }
                       *nCmiValueMax = nCmiArray[5];
                       strcpy( sRugMax, "RHX" );
                       *iRugMax = 5;
				  }
			 }
			 else if ( 7<=*iAdlSum && *iAdlSum<=12 ) {
				  if ( nCmiArray[6] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) { 
                            *nCmiValueHier = nCmiArray[6];
                            strcpy( sRugHier, "RHL" ); 
                            *iRugHier = 6;
					   }
                       *nCmiValueMax = nCmiArray[6];
                       strcpy( sRugMax, "RHL" );
                       *iRugMax = 6;
				  }
			 }
		}
        /*Classify into Medium Intensity Rehab Plus Extensive groups*****             
         *   Classify if Medium Rehab and Extensive indicators present and            
         *      (1) a previous hierarchical classification has not been made          
         *          (indicated by n_cmi_mx being at a default negative value)         
         *   or (2) yields a higher rate for index maximization.                      
         *   Determine final splits for Medium Rehab Plus Extensive residents         
         *   on the basis of ADL sum.  Accept classification into a group if CMI      
         *   for that group is higher than previous high CMI. */                        
		if ( n_reh_m==1 && (n_ext==1 && *iAdlSum>=7) ) { 
			 if ( 15<=*iAdlSum && *iAdlSum<=18 ) {
				  if ( nCmiArray[7] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) { 
                            *nCmiValueHier = nCmiArray[7];
                            strcpy( sRugHier, "RMX" ); 
                            *iRugHier = 7;
					   }
                       *nCmiValueMax = nCmiArray[7];
                       strcpy( sRugMax, "RMX" );
                       *iRugMax = 7;
				  }
			 }
			 else if ( 7<=*iAdlSum && *iAdlSum<=14 ) {
				  if ( nCmiArray[8] > *nCmiValueMax ) {
					   if ( *nCmiValueMax==-9999 ) { 
                            *nCmiValueHier = nCmiArray[8];
                            strcpy( sRugHier, "RML"); 
                            *iRugHier = 8;
					   }
                       *nCmiValueMax = nCmiArray[8];
                       strcpy( sRugMax, "RML");
                       *iRugMax = 8;
				  }
			 }
		}
        /*Classify into Low Intensity Rehab Plus Extensive group*****                 
         *   Classify if Low Rehab and Extensive indicators present and               
         *      (1) a previous hierarchical classification has not been made          
         *          (indicated by n_cmi_mx being at a default negative value)         
         *   or (2) yields a higher rate for index maximization.                      
         *   Accept classification into the Low Rehab Plus Extensive group if CMI     
         *   for that group is higher than previous high CMI.  */                     
		if ( n_reh_l==1 && (n_ext==1 && *iAdlSum >=7) ) { 
			 if ( 7<=*iAdlSum && *iAdlSum<=18 ) {
				  if ( nCmiArray[9] > *nCmiValueMax ) {
					  if ( *nCmiValueMax==-9999 ) { 
                           *nCmiValueHier = nCmiArray[9];
                           strcpy( sRugHier, "RLX" ); 
                           *iRugHier = 9;
					  }
                      *nCmiValueMax = nCmiArray[9];
                      strcpy( sRugMax, "RLX" );
                      *iRugMax = 9;
				  }
			 }
		}
  //End Classification into 53-group Rehab/ Extensive Groups*****        
  }

  /*Begin Classification into 44- and 53-group Rehab Groups*****    */           
  if ( strcmp( sModel, "44" )==0 || strcmp( sModel, "53" )==0 ) { 
       //All final splits based on ADL sum (n_iAdlSum).                            
       /*Classify into Ultra High Intensity Rehab groups*****                        
        *   Classify if Ultra High Rehab indicators present and                     
        *      (1) a previous hierarchical classification has not been made         
        *          (indicated by n_cmi_mx being at a default negative value)        
        *   or (2) yields a higher rate for index maximization.                     
        *   Determine final splits for Ultra High Intensity Rehab residents         
        *   on the basis of ADL sum.  Accept classification into a group if CMI     
        *   for that group is higher than previous high CMI.   */                     
	   if ( n_reh_u == 1 ) {
		   if ( 16<=*iAdlSum && *iAdlSum<=18 ) {
			   if ( nCmiArray[10] > *nCmiValueMax ) {
				    if ( *nCmiValueMax==-9999 ) {
                         *nCmiValueHier = nCmiArray[10];
                         strcpy( sRugHier, "RUC");
						 *iRugHier = 10; 
					}   
					*nCmiValueMax = nCmiArray[10];
                    strcpy( sRugMax, "RUC" );
                    *iRugMax = 10;
			   }
		   }
		   else if ( 9<=*iAdlSum && *iAdlSum<=15 ) {
			    if ( nCmiArray[11] > *nCmiValueMax ) {
				     if ( *nCmiValueMax==-9999 ) {
                          *nCmiValueHier = nCmiArray[11];
                          strcpy( sRugHier, "RUB");
                          *iRugHier = 11;
					 }
					 *nCmiValueMax = nCmiArray[11];
                     strcpy( sRugMax, "RUB" );
                     *iRugMax = 11;
				}
		   }
		   else if ( 4<=*iAdlSum && *iAdlSum<=8 ) {  
			   if ( nCmiArray[12] > *nCmiValueMax ) {
				   if ( *nCmiValueMax==-9999 ) {
                        *nCmiValueHier = nCmiArray[12];
                        strcpy( sRugHier, "RUA" );
                        *iRugHier = 12;
				   }
                   *nCmiValueMax = nCmiArray[12];
                   strcpy( sRugMax, "RUA" );
                   *iRugMax = 12;
			   }
		   }
	   }
       /*Classify into Very High Intensity Rehab groups*****                         
         *   Classify if Very High rehab indicators present and                       
         *      (1) a previous hierarchical classification has not been made          
         *          (indicated by n_cmi_mx being at a default negative value)         
         *   or (2) yields a higher rate for index maximization.                      
         *   Determine final splits for Very High Intensity Rehab residents           
         *   on the basis of ADL sum.  Accept classification into a group if CMI      
         *   for that group is higher than previous high CMI. */                         
	   if ( n_reh_v == 1 ) {  
			if ( 16<=*iAdlSum && *iAdlSum<=18 ) {
			     if ( nCmiArray[13] > *nCmiValueMax ) {
					  if ( *nCmiValueMax==-9999 ) {
                           *nCmiValueHier = nCmiArray[13];
                           strcpy( sRugHier, "RVC" );
                           *iRugHier = 13;
					  }                
					  *nCmiValueMax = nCmiArray[13];
                      strcpy( sRugMax, "RVC" );
                      *iRugMax = 13;
				 }
			}
			else if ( 9<=*iAdlSum && *iAdlSum<=15 ) {
				 if ( nCmiArray[14] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[14];
                           strcpy( sRugHier, "RVB" );
                           *iRugHier = 14;
					  }
                      *nCmiValueMax = nCmiArray[14];
                      strcpy( sRugMax, "RVB" );
                      *iRugMax = 14;
				 }
			}
			else if ( 4<=*iAdlSum && *iAdlSum<=8 ) {
				 if ( nCmiArray[15] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[15];
                           strcpy( sRugHier, "RVA" );
                           *iRugHier = 15;
					  }
                      *nCmiValueMax = nCmiArray[15];
                      strcpy( sRugMax, "RVA" );
                      *iRugMax = 15;
				 }
			}
	   }
       /*Classify into High Intensity Rehab groups*****                             
        *   Classify if High Rehab indicators present and                            
        *      (1) a previous hierarchical classification has not been made          
        *          (indicated by n_cmi_mx being at a default negative value)         
        *   or (2) yields a higher rate for index maximization.                      
        *   Determine final splits for High Intensity Rehab residents                
        *   on the basis of ADL sum.  Accept classification into a group if CMI      
        *   for that group is higher than previous high CMI.  */                         
       if ( n_reh_h == 1 ) {
		    if ( 13<=*iAdlSum && *iAdlSum<=18 ) {
				 if ( nCmiArray[16] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[16];
                           strcpy( sRugHier, "RHC" );
                           *iRugHier = 16;
					  }
                      *nCmiValueMax = nCmiArray[16];
                      strcpy( sRugMax, "RHC" );
                      *iRugMax = 16;
				 }
			}
			else if ( 8<=*iAdlSum && *iAdlSum<=12 ) {
				 if ( nCmiArray[17] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[17];
                           strcpy( sRugHier, "RHB" );
                           *iRugHier = 17;
					  }
                      *nCmiValueMax = nCmiArray[17];
                      strcpy( sRugMax, "RHB" );
                      *iRugMax = 17;
				 }
			}
			else if ( 4<=*iAdlSum && *iAdlSum<=7 ) {
				 if ( nCmiArray[18] > *nCmiValueMax ) {
					 if ( *nCmiValueMax == -9999 ) {
                          *nCmiValueHier = nCmiArray[18];
                          strcpy( sRugHier, "RHA" );
                          *iRugHier = 18;
					 }
                     *nCmiValueMax = nCmiArray[18];
                     strcpy( sRugMax, "RHA" );
                     *iRugMax = 18;
				 }              
			}
	   }

       /*Classify into Medium Intensity Rehab groups*****                            
        *   Classify if Medium Rehab indicators present and                          
        *      (1) a previous hierarchical classification has not been made          
        *          (indicated by n_cmi_mx being at a default negative value)         
        *   or (2) yields a higher rate for index maximization.                      
        *                                                                            
        *   Determine final splits for Medium Intensity Rehab residents              
        *   on the basis of ADL sum.  Accept classification into a group if CMI      
        *   for that group is higher than previous high CMI.  */                         
       if ( n_reh_m == 1 ) {
		    if ( 15<=*iAdlSum && *iAdlSum<=18 ) {
				 if ( nCmiArray[19] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[19];
                           strcpy( sRugHier, "RMC" );
                           *iRugHier = 19;
					  }
                      *nCmiValueMax = nCmiArray[19];
                      strcpy( sRugMax, "RMC" );
                      *iRugMax = 19;
				 }
			}
			else if ( 8<=*iAdlSum && *iAdlSum<=14 ) {
				 if ( nCmiArray[20] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[20];
                           strcpy( sRugHier, "RMB" );
                           *iRugHier = 20;
					  }                
					  *nCmiValueMax = nCmiArray[20];
                      strcpy( sRugMax, "RMB" );
                      *iRugMax = 20;
				 }
			}
			else if ( 4<=*iAdlSum && *iAdlSum<=7 ) {
				 if ( nCmiArray[21] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[21];
                           strcpy( sRugHier, "RMA" );
                           *iRugHier = 21;
					  }
                      *nCmiValueMax = nCmiArray[21];
                      strcpy( sRugMax, "RMA" );
                      *iRugMax = 21;
				 }
			}
	   }
       /*Classify into Low Intensity Rehab groups*****                              
        *   Classify if Low Rehab indicators present and                             
        *      (1) a previous hierarchical classification has not been made          
        *          (indicated by n_cmi_mx being at a default negative value)         
        *   or (2) yields a higher rate for index maximization.                      
        *   Determine final splits for Low Intensity Rehab residents                 
        *   on the basis of ADL sum.  Accept classification into a group if CMI      
        *   for that group is higher than previous high CMI. */                         
	   if ( n_reh_l == 1 ) {
		    if ( 14<=*iAdlSum && *iAdlSum<=18 ) {
				 if ( nCmiArray[22] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[22];
                           strcpy( sRugHier, "RLB" );
                           *iRugHier = 22;
					  }
                      *nCmiValueMax = nCmiArray[22];
                      strcpy( sRugMax, "RLB" );
                      *iRugMax = 22;
				 }
			}
			else if ( 4<=*iAdlSum && *iAdlSum<=13 ) {
				 if ( nCmiArray[23] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[23];
                           strcpy( sRugHier, "RLA" );
                           *iRugHier = 23;
					  }
                      *nCmiValueMax = nCmiArray[23];
                      strcpy( sRugMax, "RLA" );
                      *iRugMax = 23;
				 }             
			}
	   }
  //End Classification into 44- and 53-group Rehab Groups*****
  }

 /*Classify into Extensive Care Groups (34-, 44-, and 53-group models)*****    
  *To be classified as Extensive Care a resident must qualify on the           
  *    basis of having Extensive Care clinical indicators (n_ext = 1)  AND     
  *    an ADL sum of 7 or more  AND                                            
  *      (1) a previous hierarchical classification has not been made          
  *          (indicated by n_cmi_mx being at a default negative value)         
  *   or (2) yields a higher rate for index maximization.                      
  *    Note that residents who have Extensive Care clinical indicators but     
  *    have too low an ADL score (6 or less) are classified as Special Care    
  *    rather than Extensive Care.                                             
  *Split into Extensive Care groups is based on a count (n_ext_ct) of other    
  *   hierarchy category qualifications plus existence of                      
  *   parenteral/IV feeding (k5a) and IV medications (p1ac).  Accept           
  *   classification into a group if CMI for that group is higher than         
  *   previous high CMI.  */                                                   
  if ( n_ext==1 && *iAdlSum>=7 ) {
       n_ext_ct = n_spec + n_clin + n_impair;
	   if ( m_k5a[0] == '1' ) n_ext_ct++;
       if ( m_p1ac[0] == '1' ) n_ext_ct++;
	   if ( 4<=n_ext_ct && n_ext_ct<=5 ) {
		    if ( nCmiArray[24] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[24];
                      strcpy( sRugHier, "SE3" );
                      *iRugHier = 24;
				 }
                 *nCmiValueMax = nCmiArray[24];
                 strcpy( sRugMax, "SE3" );
                 *iRugMax = 24;
			}
	   }
	   else if ( 2<=n_ext_ct && n_ext_ct<=3 ) {
		    if ( nCmiArray[25] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[25];
                      strcpy( sRugHier, "SE2" );
                      *iRugHier = 25;
				 }
                 *nCmiValueMax = nCmiArray[25];
                 strcpy( sRugMax, "SE2" );
                 *iRugMax = 25;
			}
	   }  
	   else if ( 0<=n_ext_ct && n_ext_ct<=1 ) {
		   if ( nCmiArray[26] > *nCmiValueMax ) {
			    if ( *nCmiValueMax == -9999 ) {
                     *nCmiValueHier = nCmiArray[26];
                     strcpy( sRugHier, "SE1" );
                     *iRugHier = 26;
				}                
				*nCmiValueMax = nCmiArray[26];
                strcpy( sRugMax, "SE1" );
                *iRugMax = 26;
		   }
	   }
  }

  //Begin Classification into 34-group Rehab Groups*****                        
  if ( strcmp( sModel, "34" )== 0 ) { 
       /*Classify into 34-group model Rehab groups*****                              
        *   Classify if any rehab indicator (ultra high, very high, high, medium or  
        *   low) present and                                                         
        *      (1) a previous hierarchical classification has not been made          
        *          (indicated by n_cmi_mx being at a default negative value)         
        *   or (2) yields a higher rate for index maximization.                      
        *   Determine final splits for Low Intensity Rehab residents                 
        *   on the basis of ADL sum.  Accept classification into a group if CMI      
        *   for that group is higher than previous high CMI. */                         
	   if ( n_reh_u==1 || n_reh_v==1 || n_reh_h==1 || n_reh_m==1 || n_reh_l==1 ) {
		    if ( 17<=*iAdlSum && *iAdlSum<=18 ) {
				 if ( nCmiArray[27] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[27];
                           strcpy( sRugHier, "RAD" );
                           *iRugHier = 27;
					  }
                      *nCmiValueMax = nCmiArray[27];
                      strcpy( sRugMax, "RAD" );
                      *iRugMax = 27;
				 }
			}
			else if ( 14<=*iAdlSum && *iAdlSum<=16 ) {
				 if ( nCmiArray[28] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[28];
                           strcpy( sRugHier, "RAC" );
                           *iRugHier = 28;
					  }
                      *nCmiValueMax = nCmiArray[28];
                      strcpy( sRugMax, "RAC" );
                      *iRugMax = 28;
				 }
			}
			else if ( 10<=*iAdlSum && *iAdlSum<=13 ) {
				 if ( nCmiArray[29] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[29];
                           strcpy( sRugHier, "RAB" );
                           *iRugHier = 29;
					  }                
					  *nCmiValueMax = nCmiArray[29];
                      strcpy( sRugMax, "RAB" );
                      *iRugMax = 29;
				 }
			}
			else if ( 4<=*iAdlSum && *iAdlSum<=9 ) {
				 if ( nCmiArray[30] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[30];
                           strcpy( sRugHier, "RAA" );
                           *iRugHier = 30;
					  }
                      *nCmiValueMax = nCmiArray[30];
                      strcpy( sRugMax, "RAA" );
                      *iRugMax = 30;
				 }
			}
	   }
       //End Classification into 34-group Rehab Groups*****                        
  }

  /*Classify into Special Care Groups (34-, 44-, and 53-group models)*****      
   *To be classified as Special Care a resident must satisfy one of the         
   *   three following conditions:                                              
   *   1. The resident has both Special Care clinical indicators (n_spec = 1)   
   *      and an ADL sum of 7 or more, regardless of calculation method.        
   *   2. The calculation method is Hierarchical and the resident has both      
   *      Extensive Care indicators (n_ext = 1) and an ADL sum of 6 or less.    
   *   3. The calculation method is Index Maximizing and the resident           
   *      has Extensive Care clinical indicators (n_ext = 1) with               
   *      any ADL sum.                                                          
   *   Classify if one of these 3 conditions present and                        
   *      (1) a previous hierarchical classification has not been made          
   *          (indicated by n_cmi_mx being at a default negative value)         
   *   or (2) yields a higher rate for index maximization.                      
   *   Note that residents who have Special Care clinical indicators but        
   *   have too low an ADL score (6 or less) are classified as Clinically       
   *   Complex rather than Special Care.                                        
   *Split into Special Care groups is based on ADL sum.  Accept classification  
   *   into a group if CMI for that group is higher than previous high CMI.  */     
  if ( (n_spec==1 && *iAdlSum>=7) || n_ext==1 ) {
	   if ( 17<=*iAdlSum && *iAdlSum<=18 ) {
		    if ( nCmiArray[31] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[31];
                      strcpy( sRugHier, "SSC" );
                      *iRugHier = 31;
				 }
                 *nCmiValueMax = nCmiArray[31];
                 strcpy( sRugMax, "SSC" );
                 *iRugMax = 31;
			}      
	   }
	   else if ( 15<=*iAdlSum && *iAdlSum<=16 ) {
		    if ( nCmiArray[32] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[32];
                      strcpy( sRugHier, "SSB" );
                      *iRugHier = 32;
				 }
                 *nCmiValueMax = nCmiArray[32];
                 strcpy( sRugMax, "SSB" );
                 *iRugMax = 32;
			}
	   }
	   else if ( 4<=*iAdlSum && *iAdlSum<=14 ) {
		    if ( nCmiArray[33] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[33];
                      strcpy( sRugHier, "SSA" );
                      *iRugHier = 33;
				 }                              
				 *nCmiValueMax = nCmiArray[33];
                 strcpy( sRugMax, "SSA" );
                 *iRugMax = 33;
			}
	   }
  }

  /*Classify into Clinically Complex Groups (34-, 44-, and 53-group models)*****
   *To be classified as Clinically Complex a resident must satisfy one of the   
   *   four following conditions:                                               
   *   1. The resident has Clinically Complex clinical indicators (n_clin = 1), 
   *      regardless of calculation method.                                     
   *   2. The calculation method is Hierarchical and the resident has both      
   *      Special Care indicators (n_spec = 1) and an ADL sum of 6 or less.     
   *   3. The calculation method is Index Maximizing and the resident           
   *      has Special Care clinical indicators (n_spec = 1) with                
   *      any ADL sum.                                                          
   *   4. The calculation method is Index Maximizing and the resident           
   *      has Extensive Care clinical indicators (n_ext = 1) with               
   *      any ADL sum.                                                          
   *   Classify if one of these 4 conditions present and                        
   *      (1) a previous hierarchical classification has not been made          
   *          (indicated by n_cmi_mx being at a default negative value)         
   *   or (2) yields a higher rate for index maximization.                      
   *Split into Clinically Complex groups is based on ADL sum and depression.    
   *   Accept classification into a group if CMI for that group is higher       
   *   than previous high CMI.   */                                                 
  if ( n_clin==1 || n_spec==1 || n_ext==1 ) {
	   if ( 17<=*iAdlSum && *iAdlSum<=18 ) {
		    if ( n_depres == 1 ) {
				 if ( nCmiArray[34] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[34];
                           strcpy( sRugHier, "CC2" );
                           *iRugHier = 34;
					  }
                      *nCmiValueMax = nCmiArray[34];
                      strcpy( sRugMax, "CC2" );
                      *iRugMax = 34;
				 }
			}
			else {
				  if ( nCmiArray[35] > *nCmiValueMax ) {
					   if ( *nCmiValueMax == -9999 ) {
                            *nCmiValueHier = nCmiArray[35];
                            strcpy( sRugHier, "CC1" );
                            *iRugHier = 35;
					   }
                       *nCmiValueMax = nCmiArray[35];
                       strcpy( sRugMax, "CC1" );
                       *iRugMax = 35;
				  }
			}
	   }
	   else if ( 12<=*iAdlSum && *iAdlSum<=16 ) {
		    if ( n_depres == 1 ) {
				 if ( nCmiArray[36] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[36];
                           strcpy( sRugHier, "CB2" );
                           *iRugHier = 36;
					  }
                      *nCmiValueMax = nCmiArray[36];
                      strcpy( sRugMax, "CB2" );
                      *iRugMax = 36;
				 }
			}
			else { 
				   if ( nCmiArray[37] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[37];
                             strcpy( sRugHier, "CB1" );
                             *iRugHier = 37;
						}
                        *nCmiValueMax = nCmiArray[37];
                        strcpy( sRugMax, "CB1" );
                        *iRugMax = 37;
				   }
			}
	   }
	   else if ( 4<=*iAdlSum && *iAdlSum<=11 ) {
		    if ( n_depres == 1 ) {                
				 if ( nCmiArray[38] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[38];
                           strcpy( sRugHier, "CA2" );
                           *iRugHier = 38;
					  }
                      *nCmiValueMax = nCmiArray[38];
                      strcpy( sRugMax, "CA2" );
                      *iRugMax = 38;
				 }
			}
			else {
				  if ( nCmiArray[39] > *nCmiValueMax ) {
					   if ( *nCmiValueMax == -9999 ) {
                            *nCmiValueHier = nCmiArray[39];
                            strcpy( sRugHier, "CA1" );
                            *iRugHier = 39;
					   }
                       *nCmiValueMax = nCmiArray[39];
                       strcpy( sRugMax, "CA1" );
                       *iRugMax = 39;
				  }
			}
	   }
  }

  /*Classify into Cognitive Groups (34-, 44-, and 53-group models)*****        
   *To be classified as Cognitive Impairment the resident has Cognitive         
   *   Impairment indicators (n_impair = 1)  and an ADL sum of 10 or less  and  
   *      (1) a previous hierarchical classification has not been made          
   *          (indicated by n_cmi_mx being at a default negative value)         
   *   or (2) yields a higher rate for index maximization.                      
   *Split into Impaired Cognitive groups is based on ADL sum and nursing        
   *   rehab count (n_nrsum6).  Accept classification into a group if CMI       
   *   for that group is higher than previous high CMI.  */                      
  if ( n_impair==1 && 4<=*iAdlSum && *iAdlSum<=10 ) {
	   if ( 6<=*iAdlSum && *iAdlSum<=10 ) {
		    if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[40] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[40];
                           strcpy( sRugHier, "IB2" );
                           *iRugHier = 40;
					  }
                      *nCmiValueMax = nCmiArray[40];
                      strcpy( sRugMax, "IB2" );
                      *iRugMax = 40;
				 }
			}             
			else {
				   if ( nCmiArray[41] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[41];
                             strcpy( sRugHier, "IB1" );
                             *iRugHier = 41;
						}
                        *nCmiValueMax = nCmiArray[41];
                        strcpy( sRugMax, "IB1" );
                        *iRugMax = 41;
				   }
			}
	   }
	   else if ( 4<=*iAdlSum && *iAdlSum<=5 ) {
		    if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[42] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[42];
                           strcpy( sRugHier, "IA2" );
                           *iRugHier = 42;
					  }
                      *nCmiValueMax = nCmiArray[42];
                      strcpy( sRugMax, "IA2" );
                      *iRugMax = 42;
				 }
			}
			else {
				   if ( nCmiArray[43] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[43];
                             strcpy( sRugHier, "IA1" );
                             *iRugHier = 43;
						}
                        *nCmiValueMax = nCmiArray[43];
                        strcpy( sRugMax, "IA1" );
                        *iRugMax = 43;
				   }
			}
	   }
  }

  /*Classify into Behavioral Problems Groups (34-, 44-, and 53-group models)****
   *To be classified as Behavior Problems the resident has Behavior             
   *   Problems indicators (n_behav = 1)  and an ADL sum of 10 or less          
   *      (1) a previous hierarchical classification has not been made          
   *          (indicated by n_cmi_mx being at a default negative value)         
   *   or (2) yields a higher rate for index maximization.                      
   *Split into Behavior Problems groups is based on ADL sum and nursing         
   *   rehab count (n_nrsum6).  Accept classification into a group if CMI       
   *   for that group is higher than previous high CMI.   */                        
  if ( n_behav==1 && 4<=*iAdlSum && *iAdlSum<=10 ) {
	   if ( 6<=*iAdlSum && *iAdlSum<=10 ) {
		    if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[44] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[44];
                           strcpy( sRugHier, "BB2" );
                           *iRugHier = 44;
					  }
                      *nCmiValueMax = nCmiArray[44];
                      strcpy( sRugMax, "BB2" );
                      *iRugMax = 44;
				 }
			}
			else {
				   if ( nCmiArray[45] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[45];
                             strcpy( sRugHier, "BB1" );
                             *iRugHier = 45;
						}
                        *nCmiValueMax = nCmiArray[45];
                        strcpy( sRugMax, "BB1" );
                        *iRugMax = 45;
				   }
			}
	   }
	   else if ( 4<=*iAdlSum && *iAdlSum<=5 ) {
		    if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[46] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[46];
                           strcpy( sRugHier, "BA2" );
                           *iRugHier = 46;
					  }
                      *nCmiValueMax = nCmiArray[46];
                      strcpy( sRugMax, "BA2" );
                      *iRugMax = 46;
				 }
			}
			else {
				   if ( nCmiArray[47] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[47];
                             strcpy( sRugHier, "BA1" );
                             *iRugHier = 47;
						}
                        *nCmiValueMax = nCmiArray[47];
                        strcpy( sRugMax, "BA1" );
                        *iRugMax = 47;
				   }
			}
	   }
  }

  /*Classify into Physical Groups (34-, 44-, and 53-group models)********       
   *   A resident is classified as reduced Physical Function if                 
   *      (1) a previous hierarchical classification has not been made          
   *          (indicated by n_cmi_mx being at a default negative value)         
   *   or (2) yields a higher rate for index maximization.                      
   *Split into Physical Function groups is based on ADL sum and nursing         
   *   rehab count (n_nrsum6).  Accept classification into a group if CMI       
   *   for that group is higher than previous high CMI.  */                         
  if ( 16<=*iAdlSum && *iAdlSum<=18 ) {
	   if ( n_nrsum6 >= 2 ) {
		    if ( nCmiArray[48] > *nCmiValueMax ) {
				 if ( *nCmiValueMax == -9999 ) {
                      *nCmiValueHier = nCmiArray[48];
                      strcpy( sRugHier, "PE2" );
                      *iRugHier = 48;
				 }                  
				 *nCmiValueMax = nCmiArray[48];
                 strcpy( sRugMax, "PE2" );
                 *iRugMax = 48;
			}
	   }
	   else {
		      if ( nCmiArray[49] > *nCmiValueMax ) {
				   if ( *nCmiValueMax == -9999 ) {
                        *nCmiValueHier = nCmiArray[49];
                        strcpy( sRugHier, "PE1" );
                        *iRugHier = 49;
				   }
                   *nCmiValueMax = nCmiArray[49];
                   strcpy( sRugMax, "PE1" );
                   *iRugMax = 49;
			  }
	   }
  }
  else if ( 11<=*iAdlSum && *iAdlSum<=15 ) {
	        if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[50] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[50];
                           strcpy( sRugHier, "PD2" );
                           *iRugHier = 50;
					  }
                      *nCmiValueMax = nCmiArray[50];
                      strcpy( sRugMax, "PD2" );
                      *iRugMax = 50;
				 }
			}
			else {
				   if ( nCmiArray[51] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[51];
                             strcpy( sRugHier, "PD1" );
                             *iRugHier = 51;
						}
                        *nCmiValueMax = nCmiArray[51];
                        strcpy( sRugMax, "PD1" );
                        *iRugMax = 51;
				   }
			}
  }
  else if ( 9<=*iAdlSum && *iAdlSum<=10 ) {
	        if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[52] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[52];
                           strcpy( sRugHier, "PC2" );
                           *iRugHier = 52;
					  }
                      *nCmiValueMax = nCmiArray[52];
                      strcpy( sRugMax, "PC2" );
                      *iRugMax = 52;
				 }
			}
			else {
				   if ( nCmiArray[53] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[53];
                             strcpy( sRugHier, "PC1" );
                             *iRugHier = 53;
						}
                        *nCmiValueMax = nCmiArray[53];
                        strcpy( sRugMax, "PC1" );
                        *iRugMax = 53;
				   }
			}
  }
  else if ( 6<=*iAdlSum && *iAdlSum<=8 ) {
	        if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[54] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[54];
                           strcpy( sRugHier, "PB2" );
                           *iRugHier = 54;
					  }                                          
					  *nCmiValueMax = nCmiArray[54];
                      strcpy( sRugMax, "PB2" );
					  *iRugMax = 54;
				 }
			}
			else {
				   if ( nCmiArray[55] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[55];
                             strcpy( sRugHier, "PB1" );
                             *iRugHier = 55;
						}
                        *nCmiValueMax = nCmiArray[55];
                        strcpy( sRugMax, "PB1" );
                        *iRugMax = 55;
				   }
			}
  }
  else if ( 4<=*iAdlSum && *iAdlSum<=5 ) {
	        if ( n_nrsum6 >= 2 ) {
				 if ( nCmiArray[56] > *nCmiValueMax ) {
					  if ( *nCmiValueMax == -9999 ) {
                           *nCmiValueHier = nCmiArray[56];
                           strcpy( sRugHier, "PA2" );
                           *iRugHier = 56;
					  }                                             
					  *nCmiValueMax = nCmiArray[56];
                      strcpy( sRugMax, "PA2" );
                      *iRugMax = 56;
				 }
			}
			else {
				   if ( nCmiArray[57] > *nCmiValueMax ) {
					    if ( *nCmiValueMax == -9999 ) {
                             *nCmiValueHier = nCmiArray[57];
                             strcpy( sRugHier, "PA1" );
                             *iRugHier = 57;
						}
                        *nCmiValueMax = nCmiArray[57];
                        strcpy( sRugMax, "PA1" );
                        *iRugMax = 57;
				   }
			}
  }
  return 0;
}
